'Compilable Example:
#Compiler PBWin 10
#Compile Exe "gbtextdb.exe"
#Dim All

#Debug Error On
#Debug Display On

%Unicode=1
%UniqueNumber = 1818181818

#Include "cwindow.inc"
#Include "ListViewCtrl.inc"
#Include "HeaderCtrl.inc"

'#Resource Manifest, 1, "files\xptheme.xml"
#Resource Icon logo "files\gbtextdb.ico"
#Resource Icon xnew "files\new.ico"
#Resource Icon xedit "files\edit.ico"
#Resource Icon xdelete "files\delete.ico"
#Resource Icon xview "files\view.ico"
#Resource Icon xsearch "files\search.ico"
#Resource Icon xcopy "files\copy.ico"
#Resource Icon xcopychecked "files\copyall.ico"
#Resource Icon xxprint "files\print.ico"
#Resource Icon xfont "files\font.ico"
#Resource Icon xsettings "files\settings.ico"
#Resource Icon xhelp "files\help.ico"
#Resource Icon xsave "files\save.ico"
#Resource Icon xsaveas "files\saveas.ico"
#Resource Icon xopen "files\open.ico"
#Resource Icon xsortup "files\sortascending.ico"
#Resource Icon xsortdown "files\sortdescending.ico"
#Resource Icon xadd "files\add.ico"
#Resource Icon xviewall "files\viewall.ico"
#Resource Icon xtree "files\tree.ico"
#Resource Icon xtext "files\text.ico"
#Resource Icon xapply "files\apply.ico"
#Resource Icon xattach "files\attach.ico"
#Resource Icon xemail "files\email.ico"
#Resource Icon aaa "files\download.ico"
#Resource Icon xkey "files\keyb.ico"
#Resource Icon xdate "files\date.ico"
#Resource Icon xgray "files\graysave.ico"

%SearchAnyTerm  = 1
%SearchAllTerms = 2
%SearchAsString = 3

Enum Controls Singular
   IDC_ListView = 500
   IDC_Toolbar
   IDC_Statusbar
   IDC_TextBox
   IDC_TreeView
   IDC_Label

   IDS_Next
   IDS_Case
   IDS_Search
   IDS_SearchTerm
   IDS_Label
   IDS_STRING
   IDS_AND
   IDS_OR
   IDS_WholeWord

   IDT_New
   IDT_Open
   IDT_Save
   IDT_SaveAs
   IDT_Edit
   IDT_Add
   IDT_Delete
   IDT_View
   IDT_Apply
   IDT_Attach
   IDT_ViewAll
   IDT_Find
   IDT_Copy
   IDT_CopyChecked
   IDT_Print
   IDT_Email
   IDT_Events
   IDT_Font
   IDT_SaveEncrypted
   IDT_ShowTree
   IDT_ShowEditor
   IDT_Settings
   IDT_Help

   IDM_Test
   IDM_MRU1
   IDM_MRU2
   IDM_MRU3
   IDM_MRU4
   IDM_MRU5
   IDM_ClearHistory
   IDM_AutoSave
   IDM_ConfirmDelete
   IDM_Sep
   IDM_ClickToEdit
'   IDM_EditLabel
   IDM_AutoUpdateEditor
   IDM_ViewAttachment
   IDM_RemoveAttachment
   IDM_CompactAttachments
   IDM_ViewFullRecord
   IDM_Debug
   IDM_FileInTitle
   IDM_CollapseNodes
   IDM_ExpandNodes
   IDM_CopyNode
   IDM_ExportCSVAll
   IDM_ExportCSVVisible
   IDM_Backup
   IDM_TextMsg
   IDM_CheckAll
   IDM_UnCheckAll
   IDM_SmallToolbar
   IDM_BigEditor
   IDM_Cut
   IDM_Copy
   IDM_Paste
   IDM_Delete
   IDM_Apply
   IDM_OpenURL
   IDM_ResetColW
   IDM_ShowToolbar
   IDM_UpdateEXE
   IDM_AutoCheckEvents
   IDM_OnTop

   IDR_Name
   IDR_Loc
   IDR_Country
   IDR_Category
   IDR_Phone
   IDR_Email
   IDR_Company
   IDR_Msg
   IDR_Events
   IDR_Blog
   IDR_Copy
   IDR_SaveExit
   IDR_Cancel
   IDR_NameL
   IDR_PhoneL
   IDR_EmailL
   IDR_CompanyL
   IDR_MsgL
   IDR_LocL
   IDR_CountryL
   IDR_CategoryL
   IDR_EventsL
   IDR_BlogL

   FindNext
   FindPrevious

   AddRecord
   ViewRecord
   EditRecord
End Enum

%SavedFieldsPerRecord = 18
Type BohoData
   name As String * 35  '<--- 1st col of ListView and in TreeView
   phone As String * 20
   msg As String * 10   '<--- carrier for text messaging purposes
   email As String * 35
   company As String * 35
   loc As String * 50
   country As String * 35
   category As String * 35 '<--- used in TreeView
   events As String * 100 '<--- roughly 25 characters x 4 events
   node As String * 15
   bname As String * 50
   bstart As String * 15
   bend As String * 15
   date As String * 20
   flag As String * 1   '<--- 1=display 0=not display
   unusedA As String * 20
   unusedB As String * 20
   unusedC As String * 20
   blog As String * 500
End Type

Type DialogType
   hWin As Dword
   Flag As Dword
   iPos As Long
   iSelect As Long
   RecCount As Long
   Input As BohoData
   OutPut As BohoData
End Type

$Ver = "2.61"

Global hDlg, hFontA, hFontB, hToolbar, hTree, ghHook, hSearch, hTextBox, hContextTB, hEvents As Dword
Global hPopupOpen,hPopupSaveAs, hPopupTreeView, hPopupSettings, hPopupListView,hPopupEmail,hImageListSort As Dword
Global hHeader, hListView, hWin As Dword, SortDirection, Debug As Long, DlgData() As DialogType
Global D() As BohoData, FileChanged, ConfirmDelete, AddRecordDisplay, Snooze, SmallToolbar, BigEditor As Long
Global ShowEditor, EditRecordDisplay, ShowTree, FileInTitle, OldProcTB, WholeWords, AutoUpdateEditor As Long
Global SaveEncrypted, AutoSave, ShowToolbar, OnTop, AutoCheckEvents, CaseSensitive, SearchMode, ClickToEdit As Long, Attachment As String
Global ValidWordCharacters, SearchTerm, FileName, FontName As WStringZ * %Max_Path, FontSize, FontAttr, LastSel As Long
Global Title1,Title2,Title3,Title4,Title5,Title6,Title7,Title8 As WStringZ * %Max_Path
Global Title9,Title10,Title11,Title12,Title13,Title14,Title15,Title16,Title17 As WStringZ * %Max_Path
Global wCol1,wCol2,wCol3,wCol4,wCol5,wCol6,wCol7,wCol8,wcol9,wcol10,wcol11,wcol12,wcol13, DTag() As Long
Global hLVFile, hLVEdit, hLVAttach, hLVSettings, hLVActions As Dword, PSW, BigString As String
Global m_att, m_sprint, m_nextel, m_tmobile, m_verizon, m_alitel, m_boost, m_uscellular, m_virgin  As WStringZ * %Max_Path
Global MRU1,MRU2,MRU3,MRU4,MRU5 As WStringZ * %Max_Path

'Global OriginalEditLabelText$

#Include "files\gbonlineupdate.inc"

Function PBMain() As Long
   If InstanceTest = 0 Then Exit Function
   Local Style As Long
   Style = %WS_Child Or %WS_Visible Or %ES_MultiLine _ ' Or %ES_AutoHScroll _
      Or %ES_WantReturn Or %ES_NoHideSel Or %WS_TabStop  'Or %WS_HScroll
   Dialog New Pixels, 0, "gbTextDB " + $ver,300,300,310,260, %WS_OverlappedWindow To hDlg
   SetWindowLong(hDlg, %GWL_USERDATA, %UniqueNumber)  '<---- LONG allows up to 10 digits
   Dialog Set Icon hDlg, "logo"
   hUpdateParent = hDlg
   Control Add TextBox, hDlg, %IDC_TextBox,"-", 0,0,0,0, Style, %WS_Ex_ClientEdge
   Control Handle hDlg, %IDC_TextBox To hTextBox
   Control Add Label, hDlg, %IDC_Label,"Name" + $CrLf + "Ph#" + $CrLf + "Email" + $CrLf + "Comp" + $CrLf + "Msg" + _
      $CrLf + "Loc" + $CrLf + "Cntry" + $CrLf + "Cat" + $CrLf + "Event" + $CrLf + "Blog", 100,13,33,180, %WS_ClipSiblings Or %SS_Notify
   CreateToolbar
   Control Add Statusbar, hDlg, %IDC_StatusBar, "",0,0,0,0
   Dialog Show Modal hDlg Call DlgProc
   If RestartUpdate Then RestartUpdatedEXE
End Function

CallBack Function DlgProc() As Long
   Local i,w,h,iResult As Long, P As TooltipText Ptr, temp$, hNode As Dword
   Local LVData As NM_ListView, nmtb As TBNotify Ptr, rc As Rect, pt As Point
   Select Case Cb.Msg
      Case %WM_InitDialog
'         Debug = 1
         If Debug Then Txt.Window "Debug", 300,300,30,40 To hWin
         If IsFolder (Exe.Path$ + "temp") = %False Then MkDir Exe.Path$ + "temp"
         If IsFolder (Exe.Path$ + "backup") = %False Then MkDir Exe.Path$ + "backup"
         Settings_INI "get"
         SetDialogTitle
         CreateContextMenus
         CreateTreeView
         CreateListView
         ShowControls
         HideToolbarButtons
         OldProcTB = SetWindowLong(hTextBox, %GWL_WndProc, CodePtr(TextBoxProc))   'subclass a control
         Font New "Tahoma",10,0 To hFontA
         Control Set Font hDlg, %IDC_Toolbar, hFontA
         Control Set Font hDlg, %IDC_StatusBar, hFontA
         BuildAcceleratorTable
         LoadDataFromFileToD
         LoadListViewFromD
         If ShowTree Then LoadTreeViewFromLV
         If ShowEditor Then LoadTextBoxFromD
         Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Save, IIf(FileChanged,%TBState_Enabled,%TBState_Disabled)
         SetMenus
         Control Show State hDlg, %IDC_Toolbar, IIf(ShowToolbar, %SW_Show, %SW_Hide)
         Font New FontName, FontSize, FontAttr To hFontB
         Control Set Font hDlg, %IDC_ListView, hFontB
         Control Set Font hDlg, %IDC_TreeView, hFontB
         Control Set Font hDlg, %IDC_Label, hFontB
         Control Set Font hDlg, %IDC_TextBox, hFontB
         Dialog Post hDlg, %WM_User+500, 0, 0

      Case %WM_User+501
         Control Set Focus hDlg, %IDC_ListView
      Case %WM_User+500
         If Debug Then Txt.Print "%WM_User+500"
         Control Set Focus hDlg, %IDC_ListView
         ListView Visible hDlg, %IDC_ListView, LastSel
         ListView Select hDlg, %IDC_ListView, LastSel
         ListView_SetItemState hListView, LastSel-1, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code
         ShowSelectionInStatusBar
         ListView Get Text hDlg, %IDC_ListView, LastSel, 13 To temp$  'TreeView node
         Treeview Select hDlg, %IDC_TreeView, Val(temp$)
         SendMessage hTree, %TVM_EnsureVisible, 0, Val(temp$)
         If AutoCheckEvents Then DisplayEvents

      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDC_TextBox
               If AutoUpdateEditor And Cb.CtlMsg = %EN_Change Then ApplyChanges
            Case %IDT_Open       : OpenDataBase
            Case %IDT_New        : NewDataBase
            Case %IDT_Save
               SaveDToFile
               FileChanged = 0
               Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Save, IIf(FileChanged,%TBState_Enabled,%TBState_Disabled)
               Statusbar Set Text hDlg, %IDC_StatusBar, 1,0, "Database saved ... " + Date$ + "  " + Time$
            Case %IDT_SaveAs     : SaveDToFileAs
            Case %IDT_Add        : AddNewRecord
            Case %IDT_Edit       : EditSelectedRecord
            Case %IDT_Apply, %IDM_Apply : ApplyChanges
            Case %IDT_Attach     : AttachFile
            Case %IDT_Delete     : DeleteCheckedRecords
            Case %IDT_View       : ViewSelectedRecord
            Case %IDT_ViewAll    : ViewAllRecords
            Case %IDT_Find       : DisplayFindDialog
            Case %IDT_CopyChecked    : CopyCheckedRecords
            Case %IDT_Copy       : CopySelectedRecord
            Case %IDT_Print      : PrintCheckedRecords
            Case %IDT_Email      : SendEmail
            Case %IDM_TextMsg    : SendTextMsg
            Case %IDT_Font       : SelectMainFont
            Case %IDT_Events : DisplayEvents
            Case %IDT_ShowTree
               ShowTree = ShowTree Xor 1
               ShowControls
               ResizeWindow
               If ShowTree Then LoadTreeViewFromLV : SelectTVFromLV
               SetMenus
            Case %IDT_ShowEditor
               ShowEditor = ShowEditor Xor 1
               ShowControls
               ResizeWindow
               If ShowEditor Then LoadTextBoxFromD
               SetMenus
            Case %IDT_Settings
               If ShowEditor = 1 Or ShowTree = 1 Then
                  ShowTree = 0 : ShowEditor = 0
               Else
                  ShowTree = 1 : ShowEditor = 1
               End If
               ShowControls
               ResizeWindow
               If ShowEditor Then LoadTextBoxFromD
               If ShowTree Then LoadTreeViewFromLV : SelectTVFromLV
               SetMenus

            Case %IDT_Help
               iResult = ShellExecute(hDlg, "Open", "http://www.garybeene.com/sw/gbtextdb.htm", $Nul, $Nul, %SW_ShowNormal)

            Case %IDC_Label
               If Cb.CtlMsg = %STN_DblClk Then FakeData

            Case %IDM_Test : RunTest

            Case %IDM_MRU1 To %IDM_MRU5 : TakeMRUAction(Cb.Ctl)
            Case %IDM_ClearHistory : Reset MRU1,MRU2,MRU3,MRU4,MRU5

            Case %IDM_ResetColW  : ResetColW

            Case %IDM_Cut     : SendMessage GetFocus, %WM_CUT, 0, 0
            Case %IDM_Copy    : SendMessage GetFocus, %WM_COPY, 0, 0
            Case %IDM_Paste   : SendMessage GetFocus, %WM_PASTE, 0, 0
            Case %IDM_Delete  : SendMessage GetFocus, %WM_CLEAR, 0, 0
            Case %IDM_OpenURL : OpenURL

            Case %IDM_CollapseNodes : CollapseAllNodes
            Case %IDM_ExpandNodes   : ExpandAllNodes
            Case %IDM_CopyNode      : CopyNode

            Case %IDM_ExportCSVAll     : ExportCSVAll
            Case %IDM_ExportCSVVisible : ExportCSVVisible
            Case %IDM_Backup           : BackupDataBase

            Case %IDM_CheckAll      : CheckAll
            Case %IDM_UnCheckAll    : UnCheckAll

'            Case %IDM_EditLabel     : SetFocus hTree : TreeEditLabel

            Case %IDM_FileInTitle   : FileInTitle = FileInTitle Xor 1 : SetMenus : SetDialogTitle

            Case %IDM_ConfirmDelete : ConfirmDelete = ConfirmDelete Xor 1 : SetMenus
            Case %IDM_AutoSave      : AutoSave = AutoSave Xor 1 : SetMenus
            Case %IDM_ClickToEdit   : ClickToEdit = ClickToEdit Xor 1 : SetMenus
            Case %IDM_AutoCheckEvents : AutoCheckEvents = AutoCheckEvents Xor 1 : SetMenus
            Case %IDM_AutoUpdateEditor : AutoUpdateEditor = AutoUpdateEditor Xor 1 : SetMenus

            Case %IDM_OnTop
               OnTop = OnTop Xor 1
               If OnTop Then
                  SetWindowPos(hDlg, %HWND_TOPMOST, 0, 0, 0, 0, %SWP_NOMOVE Or %SWP_NOSIZE)  'on Top
               Else
                  SetWindowPos(hDlg, %HWND_NOTOPMOST, 0, 0, 0, 0, %SWP_NOMOVE Or %SWP_NOSIZE) 'not on Top
               End If
               SetMenus
            Case %IDT_SaveEncrypted
               SaveEncrypted = SaveEncrypted Xor 1
               SetMenus

            Case %IDM_BigEditor
               BigEditor = BigEditor Xor 1
               ResizeWindow
               SetMenus

            Case %IDM_SmallToolbar
               SmallToolbar = SmallToolbar Xor 1
               HideToolbarButtons
'               w = ShowTree * 150 + 150 + ShowEditor * 190 + BigEditor * 100
               If ShowToolbar Then Dialog Set Size hDlg, IIf(SmallToolbar,IIf(BigEditor,690,590),1060), 430
               SetMenus

            Case %IDM_ShowToolbar
               ShowToolbar = ShowToolbar Xor 1
               ShowControls
'               w = ShowTree * 150 + 150 + ShowEditor * 190 + BigEditor * 100 + ShowToolbar * SmallToolbar * (1030-470)
'               Dialog Set Size hDlg, IIf(SmallToolbar,w,1060), 430
'              If Dialog Set Size hDlg, w, 430
               If ShowToolbar Then Dialog Set Size hDlg, IIf(SmallToolbar,IIf(BigEditor,690,590),1060), 430
               ResizeWindow
               SetMenus

            Case %IDM_ViewAttachment     : ViewAttachment
            Case %IDM_RemoveAttachment   : RemoveAttachment
            Case %IDM_CompactAttachments : CompactAttachmentFile
            Case %IDM_ViewFullRecord
               ListView Get Select hDlg, %IDC_ListView To iResult
               ListView Get Text hDlg, %IDC_ListView, iResult, 12 To temp$  'Array pos
               iResult = Val(temp$)
               MsgBoxX(RecordTextB(D(iResult)), %MB_Ok + %MB_IconInformation + %MB_TaskModal, "View Full Record")

            Case %IDM_UpdateEXE
               CheckForEXEUpdates($Ver)

            Case %IDM_Debug
               Debug = Debug Xor 1
               If Debug Then
                  Txt.Window "Debug", 300,300,40,40 To hWin
               Else
                  Txt.End
               End If

            Case %IdOk
               If ClickToEdit Then EditSelectedRecord Else ViewSelectedRecord
'               If Cb.CtlMsg = %BN_Clicked And GetParent(GetFocus) = hTree Then
'                  SendMessage(hTree, %TVM_EndEditLabelNow, %False, 0)
'                  Function = 1
'               End If
            Case %IdCancel
               Dialog End hSearch
'               If hTVEdit And Len(OriginalEditLabelText$) Then
'                  SendMessage(hTree, %TVM_EndEditLabelNow, %False, 0)
'                  OriginalEditLabelText$ = ""
'               End If
         End Select

      Case %WM_LButtonUp
         pt.x = Lo(Word,Cb.LParam) : pt.y = Hi(Word,Cb.LParam)
         If pt.x < 11 Then
            If ShowTree Then
               If ShowToolbar Then
                  If pt.y < 100 Then CollapseAllNodes Else ExpandAllNodes
               Else
                  If pt.y < 40 Then CollapseAllNodes Else ExpandAllNodes
               End If
            End If
         End If


      Case %WM_ContextMenu
         Select Case GetDlgCtrlID (Cb.WParam)
            Case %IDC_ListView
               w = Lo(Integer,Cb.LParam) : h = Hi(Integer, Cb.LParam)
               ListView Get Select hDlg, %IDC_ListView To iResult
               If iResult Then TrackPopupMenu hPopupListView, %TPM_LeftAlign, w, h, 0, Cb.Hndl, ByVal 0
            Case %IDC_TreeView
               w = Lo(Integer,Cb.LParam) : h = Hi(Integer, Cb.LParam)
               ListView Get Select hDlg, %IDC_ListView To iResult
               Treeview Get Select hDlg, %IDC_TreeView To hNode
               Treeview Get Parent hDlg, %IDC_TreeView, hNode To hNode
               If iResult And hNode Then TrackPopupMenu hPopupTreeView, %TPM_LeftAlign, w, h, 0, Cb.Hndl, ByVal 0
         End Select
      Case %WM_Notify
           nmtb = Cb.LParam
           Select Case @nmtb.hdr.Code
              Case %TBN_DROPDOWN
                 Select Case @nmtb.iItem
                    Case %IDT_Email
                       Call SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                       Call MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                       Call TrackPopupMenu (hPopupEmail, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                    Case %IDT_Open
                       BuildHistoryMenu
                       Call SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                       Call MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                       Call TrackPopupMenu (hPopupOpen, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                    Case %IDT_SaveAs
                       Call SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                       Call MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                       Call TrackPopupMenu (hPopupSaveAs, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                    Case %IDT_Settings
                       Call SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                       Call MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                       Call TrackPopupMenu (hPopupSettings, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                 End Select
           End Select

         Select Case Cb.NmId
            Case %IDT_New To %IDT_Help
               Select Case Cb.NmCode
                  Case %TTN_GetDispInfo
                      P = Cb.LParam
                      @P.@lpszText = SetToolTips(Cb.NmId)
               End Select
            Case %IDC_TreeView
               Select Case Cb.NmCode
                  Case %TVN_SelChangedW, %NM_SetFocus
                     If GetFocus = hTree Then
                        Treeview Get Select hDlg, %IDC_TreeView To hNode
                        Treeview Get User hDlg, %IDC_TreeView, hNode To iResult
                        ListView Select hDlg, %IDC_ListView, iResult
                        ListView Visible hDlg, %IDC_ListView, iResult
                        ListView_SetItemState hListView, iResult-1, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code
                        If ShowEditor Then LoadTextBoxFromD
                     End If

                  Case %NM_DblClk
                     Treeview Get Select hDlg, %IDC_TreeView To hNode
                     Treeview Get Parent hDlg, %IDC_TreeView, hNode To hNode
                     If hNode Then
                        If ClickToEdit Then EditSelectedRecord Else ViewSelectedRecord
                     End If

'                  Case %TVN_BeginLabelEditW
'                     hTVEdit = SendMessage (hTree, %TVM_GetEditControl, 0, 0)
'                     Control Get Text hTree, GetDlgCtrlID(hTVEdit) To OriginalEditLabelText$
'
'                  Case %TVN_EndLabelEditW
'                     hTVEdit = SendMessage (hTree, %TVM_GetEditControl, 0, 0)
'                     Control Get Text hTree, GetDlgCtrlID(hTVEdit) To temp$  'get new text
'                     TreeView Get Select hDlg, %IDC_TreeView To hNode
'                     TreeView Get USer hDlg, %IDC_Treeview, hNode to iResult
'                     ListView Set Text hDlg, %IDC_ListView, iResult, 1, temp$  'name
'                     ListView Get Text hDlg, %IDC_ListView, iResult, 12 to tmp$  'iPos
'                     D(val(tmp$)).name = temp$
'                     Function = 1     '1=new text  0=original text

               End Select

            Case %IDC_ListView
               Select Case Cb.NmCode
                  Case %LVN_ItemChanged, %NM_SetFocus
                     ShowSelectioninStatusBar
                     If GetFocus = hListView Then
                        ListView Get Select hDlg, %IDC_ListView To iResult
                        ListView Get Text hDlg, %IDC_ListView, iResult, 13 To temp$  'TreeView node
                        Treeview Select hDlg, %IDC_TreeView, Val(temp$)
                        SendMessage hTree, %TVM_EnsureVisible, 0, Val(temp$)
                        If ShowEditor Then LoadTextBoxFromD
                     End If
                  Case %NM_DblClk
                     If ClickToEdit Then EditSelectedRecord Else ViewSelectedRecord
                  Case %LVN_ColumnClick
                     ListView Get Select hDlg, %IDC_Listview To iResult
                     ListView Get Text hDlg, %IDC_ListView, iResult, 12 To temp$  'array POS
                     ReDim DTag(UBound(D))
                     DTag(Val(temp$)) = 1

                     Type Set LVData = Cb.NmHdr$(SizeOf(LVData))
                     SortDirection = SortDirection Xor 1
                     If LVData.iSubItem+1 < 12 Then
                        Select Case LVData.iSubItem+1
                            Case 1 'name
                               If SortDirection = 1 Then Array Sort D(1), TagArray DTag() ,Call SortByNameA()
                               If SortDirection = 0 Then Array Sort D(1), TagArray DTag() ,Call SortByNameD()
                            Case 2 'phone
                               If SortDirection = 1 Then Array Sort D(1), TagArray DTag() ,Call SortByPhoneA()
                               If SortDirection = 0 Then Array Sort D(1), TagArray DTag() ,Call SortByPhoneD()
                            Case 3  'email
                               If SortDirection = 1 Then Array Sort D(1), TagArray DTag() ,Call SortByEmailA()
                               If SortDirection = 0 Then Array Sort D(1), TagArray DTag() ,Call SortByEmailD()
                            Case 4  'email
                               If SortDirection = 1 Then Array Sort D(1), TagArray DTag() ,Call SortByCompanyNameA()
                               If SortDirection = 0 Then Array Sort D(1), TagArray DTag() ,Call SortByCompanyNameD()
                            Case 5 'textmsg-name
                               If SortDirection = 1 Then Array Sort D(1), TagArray DTag() ,Call SortByMsgNameA()
                               If SortDirection = 0 Then Array Sort D(1), TagArray DTag() ,Call SortByMsgNameD()
                            Case 6 'loc-name
                               If SortDirection = 1 Then Array Sort D(1), TagArray DTag() ,Call SortByLocNameA()
                               If SortDirection = 0 Then Array Sort D(1), TagArray DTag() ,Call SortByLocNameD()
                            Case 7 'county-loc-name
                               If SortDirection = 1 Then Array Sort D(1), TagArray DTag() ,Call SortByCountryNameA()
                               If SortDirection = 0 Then Array Sort D(1), TagArray DTag() ,Call SortByCountryNameD()
                            Case 8 'category-name
                               If SortDirection = 1 Then Array Sort D(1), TagArray DTag() ,Call SortByCategoryNameA()
                               If SortDirection = 0 Then Array Sort D(1), TagArray DTag() ,Call SortByCategoryNameD()
                            Case  9 'date-name
                               If SortDirection = 1 Then Array Sort D(1), TagArray DTag() ,Call SortByDateNameA()
                               If SortDirection = 0 Then Array Sort D(1), TagArray DTag() ,Call SortByDateNameD()
                            Case  10 'attach-name
                               If SortDirection = 1 Then Array Sort D(1), TagArray DTag() ,Call SortByAttachNameA()
                               If SortDirection = 0 Then Array Sort D(1), TagArray DTag() ,Call SortByAttachNameD()
                            Case  11 'events-name
                               If SortDirection = 1 Then Array Sort D(1), TagArray DTag() ,Call SortByEventsNameA()
                               If SortDirection = 0 Then Array Sort D(1), TagArray DTag() ,Call SortByEventsNameD()
                        End Select
                        FileChanged = 1
                        Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Save, IIf(FileChanged,%TBState_Enabled,%TBState_Disabled)
                        SetHeaderIcons LVData.iSubItem
                        LoadListViewFromD
                        If ShowTree Then LoadTreeViewFromLV : SelectTVFromLV
                        If ShowEditor Then LoadTextBoxFromD

                        'get new position of DTag() that was set to 1
                        For i = 1 To UBound(DTag)
                           If DTag(i) Then w = i : Exit For
                        Next i

                        'select the ListView row containing w in POS column
                        ListView Get Count hDlg, %IDC_ListView To iResult
                        For i = 1 To iResult
                           ListView Get Text hDlg, %IDC_ListView, i, 12 To temp$  'array pos
                           If Val(temp$) = w Then
                              ListView Select hDlg, %IDC_ListView, i
                              ListView Visible hDlg, %IDC_ListView, i
                              ListView_SetItemState hListView, i-1, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code
                              Exit For
                           End If
                        Next i
                        ShowSelectionInStatusBar
                     End If
               End Select
         End Select
      Case %WM_Size
         ReSizeWindow
      Case %WM_SysCommand
         If Debug Then Txt.Print "%WM_SysCommand"
         If (Cb.WParam And &HFFF0) = %SC_Close Then    'trap Alt-F4, X-button, WindowMenu/Close
            If FileChanged Then
               If AutoSave Then
                  SaveDToFile
               Else
                  Select Case MsgBoxX("Save changes?", %MB_YesNoCancel + %MB_IconQuestion + %MB_TaskModal, "Close Application")
                     Case %IdYes
                        SaveDToFile
                     Case %IdNo
                        'no action. close without saving changes
                     Case %IdCancel
                        Function = 1 'abort close - return to application
                  End Select
               End If
            End If
         End If
      Case %WM_Destroy
         SetWindowLong hTextBox, %GWL_WNDPROC, OldProcTB   'un-subclass, restore original window procedure
         ListView Get Select hDlg, %IDC_ListView To LastSel
         ListView Get Column hDlg, %IDC_ListView, 1 To wCol1
         ListView Get Column hDlg, %IDC_ListView, 2 To wCol2
         ListView Get Column hDlg, %IDC_ListView, 3 To wCol3
         ListView Get Column hDlg, %IDC_ListView, 4 To wCol4
         ListView Get Column hDlg, %IDC_ListView, 5 To wCol5
         ListView Get Column hDlg, %IDC_ListView, 6 To wCol6
         ListView Get Column hDlg, %IDC_ListView, 7 To wCol7
         ListView Get Column hDlg, %IDC_ListView, 8 To wCol8
         ListView Get Column hDlg, %IDC_ListView, 9 To wCol9
         ListView Get Column hDlg, %IDC_ListView, 10 To wCol10
         ListView Get Column hDlg, %IDC_ListView, 11 To wCol11
         ListView Get Column hDlg, %IDC_ListView, 12 To wCol12
         ListView Get Column hDlg, %IDC_ListView, 13 To wCol13
         Settings_INI "save"
   End Select
End Function

Sub BuildAcceleratorTable
   If Debug Then Txt.Print FuncName$
   Local c As Long, ac() As ACCELAPI, hAccelerator As Dword  ' for keyboard accelator table values
   Dim ac(18)
   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_F1     : ac(c).cmd   = %IDT_Help        : Incr c
'   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_F2     : ac(c).cmd   = %IDM_EDITLABEL   : Incr c
   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_F3     : ac(c).cmd   = %IDT_Find        : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_B      : ac(c).cmd   = %IDM_ViewAttachment : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_D      : ac(c).cmd   = %IDT_Delete      : Incr c
'   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_Delete : ac(c).cmd   = %IDT_Delete      : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_E      : ac(c).cmd   = %IDT_ShowEditor  : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_F      : ac(c).cmd   = %IDT_Find        : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_G      : ac(c).cmd   = %IDM_BigEditor   : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_H      : ac(c).cmd   = %IDM_ShowToolbar : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_L      : ac(c).cmd   = %IDT_ViewAll     : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_M      : ac(c).cmd   = %IDM_ViewFullRecord : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_N      : ac(c).cmd   = %IDT_Add         : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_P      : ac(c).cmd   = %IDT_Print       : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_R      : ac(c).cmd   = %IDM_ResetColW   : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_S      : ac(c).cmd   = %IDM_SmallToolbar: Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_T      : ac(c).cmd   = %IDM_Test        : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_Y      : ac(c).cmd   = %IDM_Debug       : Incr c
   Accel Attach hDlg, AC() To hAccelerator
End Sub

Sub LoadListViewFromD
   If Debug Then Txt.Print FuncName$
   Local iPos,iCount As Long
SendMessage hListView, %WM_SetRedraw, 0, 0
   ListView Reset hDlg, %IDC_ListView
   If UBound(D) = 0 Then
SendMessage hListView, %WM_SetRedraw, 1, 0
       Exit Sub
   End If
   For iPos = 1 To UBound(D)
      If D(iPos).flag = "1" Then
         Incr iCount
         ListView Insert Item hDlg, %IDC_ListView, iCount, 0, Trim$(D(iPos).name)
         ListView Set Text hDlg, %IDC_ListView, iCount, 2, Trim$(D(iPos).phone)
         ListView Set Text hDlg, %IDC_ListView, iCount, 3, Trim$(D(iPos).email)
         ListView Set Text hDlg, %IDC_ListView, iCount, 4, Trim$(D(iPos).company)
         ListView Set Text hDlg, %IDC_ListView, iCount, 5, Trim$(D(iPos).msg)
         ListView Set Text hDlg, %IDC_ListView, iCount, 6, Trim$(D(iPos).loc)
         ListView Set Text hDlg, %IDC_ListView, iCount, 7, Trim$(D(iPos).country)
         ListView Set Text hDlg, %IDC_ListView, iCount, 8, Trim$(D(iPos).category)
         ListView Set Text hDlg, %IDC_ListView, iCount, 9, Trim$(D(iPos).date)
         ListView Set Text hDlg, %IDC_ListView, iCount, 10, Trim$(D(iPos).bname)
         ListView Set Text hDlg, %IDC_ListView, iCount, 11, Trim$(D(iPos).events)
         ListView Set Text hDlg, %IDC_ListView, iCount, 12, Trim$(Str$(iPos))
         ListView Set Text hDlg, %IDC_ListView, iCount, 13, Trim$(D(iPos).node)
      End If
   Next iPos
   ListView Select hDlg, %IDC_ListView, 1
   ListView_SetItemState hListView, 0, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code
SendMessage hListView, %WM_SetRedraw, 1, 0
   ShowSelectionInStatusBar
End Sub

Sub CreateToolbar
   If Debug Then Txt.Print FuncName$
   Local hImageList, hImageListDisabled As Dword

   ImageList New Icon 24,24,24,10 To hImageList
   ImageList Add Icon hImageList, "xsave"    '1
   ImageList Add Icon hImageList, "xedit"    '2
   ImageList Add Icon hImageList, "xdelete"  '3
   ImageList Add Icon hImageList, "xview"    '4
   ImageList Add Icon hImageList, "xsearch"  '5
   ImageList Add Icon hImageList, "xcopy"    '6
   ImageList Add Icon hImageList, "xxprint"  '7
   ImageList Add Icon hImageList, "xfont"    '8
   ImageList Add Icon hImageList, "xsettings"'9
   ImageList Add Icon hImageList, "xhelp"    '10
   ImageList Add Icon hImageList, "xnew"     '11
   ImageList Add Icon hImageList, "xsaveas"  '12
   ImageList Add Icon hImageList, "xopen"    '13
   ImageList Add Icon hImageList, "xadd"     '14
   ImageList Add Icon hImageList, "xviewall" '15
   ImageList Add Icon hImageList, "xcopychecked" '16
   ImageList Add Icon hImageList, "xtree"    '17
   ImageList Add Icon hImageList, "xtext"    '18
   ImageList Add Icon hImageList, "xapply"   '19
   ImageList Add Icon hImageList, "xattach"  '20
   ImageList Add Icon hImageList, "xemail"   '21
   ImageList Add Icon hImageList, "xkey"     '22
   ImageList Add Icon hImageList, "xdate"    '23

   ImageList New Icon 24,24,24,1 To hImageListDisabled
   ImageList Add Icon hImageListDisabled, "xgray"     '1

    Control Add Toolbar, hDlg, %IDC_Toolbar,"", 0,0,0,0, %TbStyle_Tooltips Or %TbStyle_Flat Or %WS_Child
    Control Handle hDlg, %IDC_Toolbar To hToolbar
    SendMessage hToolbar, %TB_SETEXTENDEDSTYLE, 0, %TBSTYLE_EX_DRAWDDARROWS

    Toolbar Set ImageList hDlg, %IDC_Toolbar, hImageList, 0             'default imagelist
    Toolbar Set ImageList hDlg, %IDC_Toolbar, hImageListDisabled, 1     'disabled imagelist
    Toolbar Add Button  hDlg, %IDC_Toolbar, 13, %IDT_Open,  %TbStyle_Button Or %TbStyle_DropDown, "Open"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 11, %IDT_New,  %TbStyle_Button, "New"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 1, %IDT_Save,  %TbStyle_Button, "Save"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 12, %IDT_SaveAs,  %TbStyle_Button Or %TbStyle_DropDown, "SaveAs"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 5
    Toolbar Add Button  hDlg, %IDC_Toolbar, 2, %IDT_Edit,  %TbStyle_Button,"Edit"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 14, %IDT_Add,  %TbStyle_Button, "Add"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 3, %IDT_Delete,  %TbStyle_Button,"Delete"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 4, %IDT_View,  %TbStyle_Button, "View"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 5
    Toolbar Add Button  hDlg, %IDC_Toolbar, 20, %IDT_Attach,  %TbStyle_Button, "Attach"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 19, %IDT_Apply,  %TbStyle_Button, "Apply"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 5
    Toolbar Add Button  hDlg, %IDC_Toolbar, 15, %IDT_ViewAll,  %TbStyle_Button, "List All"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 5, %IDT_Find,  %TbStyle_Button, "Find"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 5
    Toolbar Add Button  hDlg, %IDC_Toolbar, 6, %IDT_Copy,  %TbStyle_Button, "Copy"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 16, %IDT_CopyChecked,  %TbStyle_Button, "Copy"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 7, %IDT_Print,  %TbStyle_Button, "Print"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 21, %IDT_Email,  %TbStyle_Button Or %TbStyle_DropDown, "Email"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 5
    Toolbar Add Button  hDlg, %IDC_Toolbar, 23, %IDT_Events,  %TbStyle_Button, "Events"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 8, %IDT_Font,  %TbStyle_Button, "Font"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 18, %IDT_ShowEditor,  %TbStyle_Check, "Editor"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 17, %IDT_ShowTree,  %TbStyle_Check, "Tree"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 22, %IDT_SaveEncrypted,  %TbStyle_Check, "Encrypt"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 9, %IDT_Settings,  %TbStyle_Button Or %TbStyle_DropDown, "Settings"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 10, %IDT_Help,  %TbStyle_Button, "Help"
End Sub

Sub SelectMainFont
   If Debug Then Txt.Print FuncName$
   Local fName As String, fPoints, fStyle, fColor, CharSet, Style As Long
   Style = %CF_ScreenFonts Or %CF_ForceFontExist Or %CF_NoScriptSel Or %CF_NoSimulations 'Or IIf(FixedPitch,%CF_FixedPitchOnly,0)
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(FontDialogProc), GetModuleHandle(""), GetCurrentThreadId)
   Display Font hDlg, 100,100, FontName, FontSize, FontAttr, Style To fName, fPoints, fStyle, fColor, CharSet
   If Len(fName) Then
      FontName = fName : FontSize = fPoints : FontAttr = fStyle
      Font New FontName, FontSize, FontAttr To hFontB
      Control Set Font hDlg, %IDC_ListView, hFontB
      Control Set Font hDlg, %IDC_TreeView, hFontB
      Control Set Font hDlg, %IDC_TextBox, hFontB
   End If
End Sub

Function FontDialogProc(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Local szTemp As WStringZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr
    Function = CallNextHookEx(ByVal ghHook, ByVal nCode, ByVal wParam, ByVal lParam)
    If nCode < 0 Then Exit Function
    If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx ghHook
    If nCode = %HCBT_CREATEWND Then
        cw = lParam         ' Get pointer to CBT_CREATEWND struct so we can...    TT: Nick Melnick
        cst = @cw.lpcs      ' get a pointer to the CREATESTRUCT struct
        GetClassName wParam, szTemp, %Max_Path      ' for each window / control as it is created
        If UCase$(szTemp) = "#32770" Then @cst.cy = @cst.cy - 165 : @cst.cx = @cst.cx - 10  'dialog
    End If
End Function

Sub Settings_INI(Task$)
   If Debug Then Txt.Print FuncName$
   Local x As Long, y As Long
   Local xResult, yResult, temp, INIFileName As WStringZ*%Max_Path
   INIFileName = Exe.Path$ + Exe.Name$ + ".ini"
   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "300", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "300", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult), Val(yResult)   'left/top
      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "1060", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "400", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult), Val(yResult)   'width/height
      'get value for string variables
      Getprivateprofilestring "All", "FileName", Exe.Path$ + "noname.txt", FileName, %Max_Path, INIFileName
      Getprivateprofilestring "All", "FontName", "Tahoma", FontName, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Searchterm", "", SearchTerm, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Title1", "Name",       Title1, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Title2", "Phone",      Title2, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Title3", "Email",      Title3, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Title4", "Company",      Title4, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Title5", "TextMsg",    Title5, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Title6", "Loc",        Title6, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Title7", "Country",    Title7, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Title8", "Category",   Title8, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Title9", "Date",       Title9, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Title10", "Attachment",Title10, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Title11", "Events",    Title11, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Title12", "Pos",       Title12, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Title13", "Node",      Title13, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Title14", "UnusedA",   Title14, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Title15", "UnusedB",   Title15, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Title16", "UnusedC",   Title16, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Title17", "Blog",      Title17, %Max_Path, INIFileName
      Getprivateprofilestring "All", "MRU1", "", MRU1, %Max_Path, INIFileName
      Getprivateprofilestring "All", "MRU2", "", MRU2, %Max_Path, INIFileName
      Getprivateprofilestring "All", "MRU3", "", MRU3, %Max_Path, INIFileName
      Getprivateprofilestring "All", "MRU4", "", MRU4, %Max_Path, INIFileName
      Getprivateprofilestring "All", "MRU5", "", MRU5, %Max_Path, INIFileName

      Getprivateprofilestring "All", "m_att", "txt.att.net",             m_att, %Max_Path, INIFileName
      Getprivateprofilestring "All", "m_sprint", "pm.sprint.com",        m_sprint, %Max_Path, INIFileName
      Getprivateprofilestring "All", "m_nextel", "messaging.nextel.com", m_nextel, %Max_Path, INIFileName
      Getprivateprofilestring "All", "m_tmobile", "tmomail.net",         m_tmobile, %Max_Path, INIFileName
      Getprivateprofilestring "All", "m_verizon", "vtext.com",           m_verizon, %Max_Path, INIFileName
      Getprivateprofilestring "All", "m_alitel", "message.alitel.com",   m_alitel, %Max_Path, INIFileName
      Getprivateprofilestring "All", "m_boost", "myboostmobile.com",     m_boost, %Max_Path, INIFileName
      Getprivateprofilestring "All", "m_uscellular", "email.uscc.net",   m_uscellular, %Max_Path, INIFileName
      Getprivateprofilestring "All", "m_virgin", "vmobl.com",            m_virgin, %Max_Path, INIFileName

      Getprivateprofilestring "All", "ValidWordCharacters", Chr$(48 To 57, 65 To 90, 95, 97 To 122), ValidWordCharacters, %Max_Path, INIFileName

      'get value for numeric variables
      Getprivateprofilestring "All", "FontSize", "10", temp, %Max_Path, INIFileName:  FontSize = Val(temp)
      Getprivateprofilestring "All", "FontAttr", "0", temp, %Max_Path, INIFileName:  FontAttr = Val(temp)
      Getprivateprofilestring "All", "LastSel", "1", temp, %Max_Path, INIFileName:  LastSel = Val(temp)
      Getprivateprofilestring "All", "ConfirmDelete", "1", temp, %Max_Path, INIFileName:  ConfirmDelete = Val(temp)
      Getprivateprofilestring "All", "AutoSave", "1", temp, %Max_Path, INIFileName:  AutoSave = Val(temp)
      Getprivateprofilestring "All", "FileInTitle", "1", temp, %Max_Path, INIFileName:  FileIntitle = Val(temp)
      Getprivateprofilestring "All", "ShowToolbar", "1", temp, %Max_Path, INIFileName:  ShowToolbar = Val(temp)
      Getprivateprofilestring "All", "SmallToolbar", "0", temp, %Max_Path, INIFileName:  SmallToolbar = Val(temp)
      Getprivateprofilestring "All", "BigEditor", "0", temp, %Max_Path, INIFileName:  BigEditor = Val(temp)
      Getprivateprofilestring "All", "SaveEncrypted", "0", temp, %Max_Path, INIFileName:  SaveEncrypted = Val(temp)
      Getprivateprofilestring "All", "OnTop", "0", temp, %Max_Path, INIFileName:  OnTop = Val(temp)
      Getprivateprofilestring "All", "AutoCheckEvents", "0", temp, %Max_Path, INIFileName:  AutoCheckEvents = Val(temp)
      Getprivateprofilestring "All", "Case Sensitive", "0", temp, %Max_Path, INIFileName:  CaseSensitive = Val(temp)
      Getprivateprofilestring "All", "SearchMode", Str$(%SearchAsString), temp, %Max_Path, INIFileName:  SearchMode = Val(temp)
      Getprivateprofilestring "All", "ShowTree", "1", temp, %Max_Path, INIFileName:  ShowTree = Val(temp)
      Getprivateprofilestring "All", "ShowEditor", "1", temp, %Max_Path, INIFileName:  ShowEditor = Val(temp)
      Getprivateprofilestring "All", "ClickToEdit", "0", temp, %Max_Path, INIFileName:  ClickToEdit = Val(temp)
      Getprivateprofilestring "All", "WholeWords", "0", temp, %Max_Path, INIFileName  :  WholeWords = Val(temp)
      Getprivateprofilestring "All", "AutoUpdateEditor", "0", temp, %Max_Path, INIFileName  :  AutoUpdateEditor = Val(temp)

      Getprivateprofilestring "All", "wCol1", "154",  temp, %Max_Path, INIFileName:  wCol1 = Val(temp)  'name
      Getprivateprofilestring "All", "wCol2", "100",  temp, %Max_Path, INIFileName:  wCol2 = Val(temp)  'phone
      Getprivateprofilestring "All", "wCol3", "175",  temp, %Max_Path, INIFileName:  wCol3 = Val(temp)  'email
      Getprivateprofilestring "All", "wCol4", "175",  temp, %Max_Path, INIFileName:  wCol4 = Val(temp)  'company
      Getprivateprofilestring "All", "wCol5", "80",   temp, %Max_Path, INIFileName:  wCol5 = Val(temp)   'msg
      Getprivateprofilestring "All", "wCol6", "120",  temp, %Max_Path, INIFileName:  wCol6 = Val(temp)  'loc
      Getprivateprofilestring "All", "wCol7", "110",  temp, %Max_Path, INIFileName:  wCol7 = Val(temp) 'country
      Getprivateprofilestring "All", "wCol8", "100",  temp, %Max_Path, INIFileName:  wCol8 = Val(temp)  'category
      Getprivateprofilestring "All", "wCol9", "140",  temp, %Max_Path, INIFileName:  wCol9 = Val(temp) 'date
      Getprivateprofilestring "All", "wCol10", "150",  temp, %Max_Path, INIFileName:  wCol10 = Val(temp)  'attachment
      Getprivateprofilestring "All", "wCol11", "150", temp, %Max_Path, INIFileName:  wCol11 = Val(temp)'events
      Getprivateprofilestring "All", "wCol12", "40",  temp, %Max_Path, INIFileName:  wCol12 = Val(temp) 'pos
      Getprivateprofilestring "All", "wCol13", "100", temp, %Max_Path, INIFileName:  wCol13 = Val(temp)'node

   End If

   If Task$ = "save" Then
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If
      'save string variables
      WritePrivateProfileString "All", "FileName",FileName, INIFileName
      WritePrivateProfileString "All", "FontName",FontName, INIFileName
      WritePrivateProfileString "All", "SearchTerm",SearchTerm, INIFileName

      WritePrivateProfileString "All", "MRU1", MRU1, INIFileName
      WritePrivateProfileString "All", "MRU2", MRU2, INIFileName
      WritePrivateProfileString "All", "MRU3", MRU3, INIFileName
      WritePrivateProfileString "All", "MRU4", MRU4, INIFileName
      WritePrivateProfileString "All", "MRU5", MRU5, INIFileName

      'save numeric variables
      WritePrivateProfileString "All", "FontSize", (Str$(FontSize)), INIFileName
      WritePrivateProfileString "All", "FontAttr", (Str$(FontAttr)), INIFileName
      WritePrivateProfileString "All", "LastSel", (Str$(LastSel)), INIFileName
      WritePrivateProfileString "All", "ConfirmDelete", (Str$(ConfirmDelete)), INIFileName
      WritePrivateProfileString "All", "AutoSave", (Str$(AutoSave)), INIFileName
      WritePrivateProfileString "All", "FileInTitle", (Str$(FileInTitle)), INIFileName
      WritePrivateProfileString "All", "ShowToolbar", (Str$(ShowToolbar)), INIFileName
      WritePrivateProfileString "All", "SmallToolbar", (Str$(SmallToolbar)), INIFileName
      WritePrivateProfileString "All", "BigEditor", (Str$(BigEditor)), INIFileName
      WritePrivateProfileString "All", "SaveEncrypted", (Str$(SaveEncrypted)), INIFileName
      WritePrivateProfileString "All", "OnTop", (Str$(OnTop)), INIFileName
      WritePrivateProfileString "All", "AutoCheckEvents", (Str$(AutoCheckEvents)), INIFileName
      WritePrivateProfileString "All", "Case Sensitive", (Str$(CaseSensitive)), INIFileName
      WritePrivateProfileString "All", "SearchMode", (Str$(SearchMode)), INIFileName
      WritePrivateProfileString "All", "ShowTree", (Str$(ShowTree)), INIFileName
      WritePrivateProfileString "All", "ShowEditor", (Str$(ShowEditor)), INIFileName
      WritePrivateProfileString "All", "ClickToEdit", (Str$(ClickToEdit)), INIFileName
      WritePrivateProfileString "All", "WholeWords", (Str$(WholeWords)), INIFileName
      WritePrivateProfileString "All", "AutoUpdateEditor", (Str$(AutoUpdateEditor)), INIFileName

      WritePrivateProfileString "All", "wCol1", (Str$(wCol1)), INIFileName
      WritePrivateProfileString "All", "wCol2", (Str$(wCol2)), INIFileName
      WritePrivateProfileString "All", "wCol3", (Str$(wCol3)), INIFileName
      WritePrivateProfileString "All", "wCol4", (Str$(wCol4)), INIFileName
      WritePrivateProfileString "All", "wCol5", (Str$(wCol5)), INIFileName
      WritePrivateProfileString "All", "wCol6", (Str$(wCol6)), INIFileName
      WritePrivateProfileString "All", "wCol7", (Str$(wCol7)), INIFileName
      WritePrivateProfileString "All", "wCol8", (Str$(wCol8)), INIFileName
      WritePrivateProfileString "All", "wCol9", (Str$(wCol9)), INIFileName
      WritePrivateProfileString "All", "wCol10", (Str$(wCol10)), INIFileName
      WritePrivateProfileString "All", "wCol11", (Str$(wCol11)), INIFileName
      WritePrivateProfileString "All", "wCol12", (Str$(wCol12)), INIFileName
      WritePrivateProfileString "All", "wCol13", (Str$(wCol13)), INIFileName
   End If
End Sub

Sub AddNewRecord
   If Debug Then Txt.Print FuncName$
   If AddRecordDisplay Then Exit Sub   'in case Record Dialog is already displayed

   'open record dialog
   AddRecordDisplay = 1
   DisplayRecordDialog("Add New Record", %AddRecord, 0, 0)
End Sub

Sub EditSelectedRecord
   If Debug Then Txt.Print FuncName$
   If EditRecordDisplay Then Exit Sub   'in case Record Dialog is already displayed
   Local iPos, iResult As Long, temp$

   'get selection. exit if no selection
   ListView Get Select hDlg, %IDC_ListView To iResult
   If iResult = 0 Then Beep : Exit Sub

   'get record position of selection in array D()
   ListView Get Text hDlg, %IDC_ListView, iResult, 12 To temp$  'array POS
   iPos = Val(temp$)

   'open record dialog
   EditRecordDisplay = 1
   DisplayRecordDialog("Edit Record", %EditRecord, iPos, iResult)  'arraypos LVpos
End Sub

Sub DeleteCheckedRecords
   If Debug Then Txt.Print FuncName$
   Local i,iPos,iCount,iSelected,iDeleteCount,iDeletedBelow,iDeleted,LastDeletedPos As Long, temp$

   If GetFocus <> hListView Then Exit Sub

   'see if there are any items checked. if not, exit
   ListView Get Count hDlg, %IDC_ListView To iCount
   ListView Get Select hDlg, %IDC_ListView To iSelected

   For iPos = 1 To iCount
      If ListView_GetCheckState(hListView,iPos-1) And iPos <> iSelected Then Incr iDeleteCount
   Next
   iDeleteCount = iDeleteCount + IIf(iSelected,1,0)
   If iDeleteCount = 0 Then Beep : Statusbar Set Text hDlg, %IDC_Statusbar, 1,0, "No records checked/selected ..." : Exit Sub

   'confirm delete, as required by setting
   If ConfirmDelete Then
      If MsgBoxX("Delete " + Str$(iDeleteCount) + " checked/selected records?", %MB_OkCancel + %MB_IconQuestion, "Delete") = %IdCancel Then
         Statusbar Set Text hDlg, %IDC_Statusbar, 1,0, "Delete cancelled ..."
         Beep : Exit Sub : End If
   End If

   'delete selected
   If iSelected Then
      ListView Get Text hDlg, %IDC_ListView, iSelected, 12 To temp$   'array pos
      iPos = Val(temp$)
      Array Delete D(iPos) : Incr iDeleted : LastDeletedPos = iPos
      ListView Delete Item hDlg, %IDC_ListView, iSelected
   End If

   'delete checked, starting at end of list
   ListView Get Count hDlg, %IDC_ListView To iCount
   For i = iCount To 1 Step - 1
      If ListView_GetCheckState(hListView,i-1) Then
         If i < iSelected Then Incr iDeletedBelow
         ListView Get Text hDlg, %IDC_ListView, i, 12 To temp$  'array position
         iPos = Val(temp$)
         Array Delete D(iPos) : Incr iDeleted : LastDeletedPos = i
      End If
   Next i

   'resize D(), show results in ListView
   FileChanged = 1
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Save, IIf(FileChanged,%TBState_Enabled,%TBState_Disabled)
   ReDim Preserve D(0 To UBound(D)-iDeleted)
   LoadListViewFromD
   If ShowTree Then LoadTreeViewFromLV : SelectTVFromLV
   If ShowEditor Then LoadTextBoxFromD

   If iSelected Then
      LastDeletedPos = iSelected - iDeletedBelow
      If LastDeletedPos > UBound(D) Then LastDeletedPos = UBound(D)
      ListView Select hDlg, %IDC_ListView, LastDeletedPos
      ListView_SetItemState hListView, LastDeletedPos-1, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code
   End If
   ShowSelectionInStatusBar
End Sub

Sub CopySelectedRecord
   If Debug Then Txt.Print FuncName$
   Local iResult As Long, temp$
   ListView Get Select hDlg, %IDC_ListView To iResult
   If iResult = 0 Then Beep : Exit Sub

   ListView Get Text hDlg, %IDC_ListView, iResult, 12 To temp$  'array POS
   Clipboard Reset
   Clipboard Set Text RecordText(Val(temp$),$CrLf)
End Sub

Sub CopyCheckedRecords
   If Debug Then Txt.Print FuncName$
   Local iPos,iCount,iChecked,iMax As Long, temp$, tmp$
   ListView Get Count hDlg, %IDC_ListView To iMax
   For iPos = 1 To iMax
      iChecked = ListView_GetCheckState(hListView,iPos-1)
      If iChecked Then
         ListView Get Text hDlg, %IDC_ListView, iPos, 12 To tmp$ 'Array pos
         temp$ = temp$ + $CrLf + Repeat$(20,"=") + $CrLf + RecordTextB(D(Val(tmp$)))
         Incr iCount
      End If
   Next iPos

   If iCount Then
      Clipboard Reset
      Clipboard Set Text LTrim$(temp$,$CrLf)
      Statusbar Set Text hDlg, %IDC_Statusbar, 1,0,"Items Copied:" + Str$(iCount)
   Else
      Beep
   End If
End Sub

Sub CopyAllVisibleRecords
   If Debug Then Txt.Print FuncName$
   Local iPos,iCount As Long, temp$
   For iPos = 1 To UBound(D)
      If D(iPos).flag = "1" Then temp$ = temp$ + $CrLf + RecordTextB(D(iPos)) : Incr iCount
   Next iPOs
   If Len(temp$) Then
      Clipboard Reset
      Clipboard Set Text LTrim$(temp$,$CrLf)
      Statusbar Set Text hDlg, %IDC_Statusbar, 1,0,"Items Copied:" + Str$(iCount)
   Else
      Beep  'no items visible
   End If
End Sub

Sub PrintCheckedRecords
   If Debug Then Txt.Print FuncName$
   Local iPos,iCount,iChecked,iMax As Long, tmp$
   ListView Get Count hDlg, %IDC_ListView To iMax
   XPrint Attach Default
   XPrint "gbTextDB Record Listing (Checked Records Only)"
   XPrint '======================================"
   XPrint
   For iPos = 1 To iMax
      iChecked = ListView_GetCheckState(hListView,iPos-1)
      If iChecked Then
         ListView Get Text hDlg, %IDC_ListView, iPos, 12 To tmp$   'Array pos
         If Len(Trim$(D(iPos).name))     Then XPrint Trim$(D(Val(tmp$)).name)
         If Len(Trim$(D(iPos).phone))  Then XPrint Trim$(D(Val(tmp$)).phone)
         If Len(Trim$(D(iPos).email))  Then XPrint Trim$(D(Val(tmp$)).email)
         If Len(Trim$(D(iPos).company))  Then XPrint Trim$(D(Val(tmp$)).company)
         If Len(Trim$(D(iPos).msg))  Then XPrint Trim$(D(Val(tmp$)).msg)
         If Len(Trim$(D(iPos).loc))     Then XPrint Trim$(D(Val(tmp$)).loc)
         If Len(Trim$(D(iPos).country))  Then XPrint Trim$(D(Val(tmp$)).country)
         If Len(Trim$(D(iPos).category))  Then XPrint Trim$(D(Val(tmp$)).category)
         If Len(Trim$(D(iPos).events))  Then XPrint Trim$(D(Val(tmp$)).events)
         If Len(Trim$(D(iPos).date))  Then XPrint Trim$(D(Val(tmp$)).date)
         If Len(Trim$(D(iPos).blog))  Then XPrint Trim$(D(Val(tmp$)).blog)
         XPrint
         XPrint Repeat$(20,"=")
         XPrint
         Incr iCount
         If iCount > 1 And (iCount Mod 5 = 0) Then XPrint FormFeed
      End If
   Next iPos
      XPrint Close

   If iCount Then
      Statusbar Set Text hDlg, %IDC_Statusbar, 1,0,"Items Printed:" + Str$(iCount)
   Else
      Beep
   End If
End Sub

Sub ViewSelectedRecord
   If Debug Then Txt.Print FuncName$
   Local iPos As Long, temp$
   ListView Get Select hDlg, %IDC_ListView, 1 To iPos
   If iPos = 0 Then Beep : Exit Sub
   ListView Get Text hDlg, %IDC_ListView, iPos, 12 To temp$  'array POS
   DisplayRecordDialog("View Record", %ViewRecord, Val(temp$),0)
End Sub

Sub ShowSelectioninStatusBar
   If Debug Then Txt.Print FuncName$
   Local iPos,iCount As Long, temp$

   ListView Get Count hDlg, %IDC_ListView To iCount
   If iCount = 0 Then
      Statusbar Set Text hDlg, %IDC_StatusBar, 1,0, "Database is empty!"
      Exit Sub
   End If

   ListView Get Select hDlg, %IDC_ListView To iPos
   If iPos Then
      ListView Get Text hDlg, %IDC_ListView, iPos, 12 To temp$  'array POS
      iPos = Val(temp$)
      If Len(Trim$(D(iPos).name))     Then temp$ = Trim$(D(iPos).name)
      If Len(Trim$(D(iPos).phone))    Then temp$ = temp$ + " : " + Trim$(D(iPos).phone)
      If Len(Trim$(D(iPos).email))    Then temp$ = temp$ + " : " + Trim$(D(iPos).email)
      If Len(Trim$(D(iPos).company))  Then temp$ = temp$ + " : " + Trim$(D(iPos).company)
      If Len(Trim$(D(iPos).msg))      Then temp$ = temp$ + " : " + Trim$(D(iPos).msg)
      If Len(Trim$(D(iPos).loc))      Then temp$ = temp$ + " : " + Trim$(D(iPos).loc)
      If Len(Trim$(D(iPos).country))  Then temp$ = temp$ + " : " + Trim$(D(iPos).country)
      If Len(Trim$(D(iPos).category)) Then temp$ = temp$ + " : " + Trim$(D(iPos).category)
      If Len(Trim$(D(iPos).events))   Then temp$ = temp$ + " : " + Trim$(D(iPos).events)
      Statusbar Set Text hDlg, %IDC_StatusBar, 1, 0, temp$ 'RecordText(iPos," : ")
   Else
      Statusbar Set Text hDlg, %IDC_StatusBar, 1, 0, ""
   End If
End Sub

Function SetToolTips(cID As Long) As String
   If Debug Then Txt.Print FuncName$
   Select Case cID         'or this:   @P.hdr.idFrom
      Case %IDT_Open       : Function = "Open Database File"
      Case %IDT_New        : Function = "New Database"
      Case %IDT_Save       : Function = "Save Database"
      Case %IDT_SaveAs     : Function = "Save Database File As ..."

      Case %IDT_Edit       : Function = "Edit Selected Record"
      Case %IDT_Add        : Function = "Add New Record"
      Case %IDT_Delete     : Function = "Delete Checked Record(s)"
      Case %IDT_View       : Function = "View selected Record"

      Case %IDT_Attach     : Function = "Attach File to Record"
      Case %IDT_Apply      : Function = "Apply Content of Editor"

      Case %IDT_ViewAll    : Function = "View All Records in ListView"
      Case %IDT_Find       : Function = "Open Find Dialog"

      Case %IDT_Copy       : Function = "Copy Selected Record"
      Case %IDT_CopyChecked    : Function = "Copy Checked Record(s)"
      Case %IDT_Print      : Function = "Print Checked Record(s)"
      Case %IDT_Email      : Function = "Send Email (Selected Record)"

      Case %IDT_Events     : Function = "Display Events for Selected Record"
      Case %IDT_Font       : Function = "Display Font Dialog"

      Case %IDT_ShowEditor : Function = "Show Text Editor"
      Case %IDT_ShowTree   : Function = "Show TreeView"
      Case %IDT_SaveEncrypted : Function = "Encrypt File on Save"

      Case %IDT_Settings   : Function = "Display TreeView/Editor"
      Case %IDT_Help       : Function = "Open Help dialog"
   End Select
End Function

Function MsgBoxX(msg$,Flag As Long,caption$) As Long
   If Debug Then Txt.Print FuncName$
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(SBProc), GetModuleHandle(""), GetCurrentThreadId)
   Function = MessageBox( 0, (msg$), (caption$), Flag)
End Function

Function SBProc(ByVal lMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local x As Long, y As Long    'MsgBoxX is approximately 200x200
   CenterOverDialog 370,170,x,y
   If lMsg = %HCBT_ACTIVATE Then
      SetWindowPos wParam, 0, x,y, 0, 0, %SWP_NOSIZE Or %SWP_NOACTIVATE Or %SWP_NOZORDER
      UnhookWindowsHookEx ghHook
   End If
End Function

Sub CenterOverDialog(BoxX As Long, BoxY As Long, CenterX As Long, CenterY As Long)
   If Debug Then Txt.Print FuncName$
   'gets top/left position to center Box over Dialog
   'you need to know, or at least estimate, the Box size
   Local x As Long, y As Long, w As Long, h As Long
   Dialog Get Loc hDlg To x,y
   Dialog Get Size hDlg To w,h
   CenterX = x + (w-BoxX)/2
   CenterY = y + (h-BoxY)/2
End Sub

Sub RunTest
  If Debug Then Txt.Print FuncName$
  FakeData
End Sub

Sub CreateContextMenus
    If Debug Then Txt.Print FuncName$

    Menu New PopUp To hPopupOpen

    Menu New PopUp To hPopupEmail
    Menu Add String, hPopupEmail, "Send Text Message", %IDM_TextMsg, %MF_Enabled

    Menu New PopUp To hPopupSaveAs
    Menu Add String, hPopupSaveAs, "Export to CSV (All Records)", %IDM_ExportCSVAll, %MF_Enabled
    Menu Add String, hPopupSaveAs, "Export to CSV (Listed Records Only)", %IDM_ExportCSVVisible, %MF_Enabled
    Menu Add String, hPopupSaveAs, "-", %IDM_Sep, %MF_Enabled
    Menu Add String, hPopupSaveAs, "Back Up Database", %IDM_Backup, %MF_Enabled

    Menu New PopUp To hPopupSettings
    Menu Add String, hPopupSettings, "Confirm Delete", %IDM_ConfirmDelete, %MF_Enabled
    Menu Add String, hPopupSettings, "AutoSave On Exit", %IDM_AutoSave, %MF_Enabled
    Menu Add String, hPopupSettings, "FileName In Title", %IDM_FileInTitle, %MF_Enabled
    Menu Add String, hPopupSettings, "Double-Click To Edit", %IDM_ClickToEdit, %MF_Enabled
    Menu Add String, hPopupSettings, "On Top", %IDM_OnTop, %MF_Enabled
    Menu Add String, hPopupSettings, "Event Report on Startup", %IDM_AutoCheckEvents, %MF_Enabled
    Menu Add String, hPopupSettings, "AutoUpdate From Editor", %IDM_AutoUpdateEditor, %MF_Enabled
    Menu Add String, hPopupSettings, "Small Toolbar", %IDM_SmallToolbar, %MF_Enabled
    Menu Add String, hPopupSettings, "Large Editor", %IDM_BigEditor, %MF_Enabled
    Menu Add String, hPopupSettings, "-", %IDM_Sep, %MF_Enabled
    Menu Add String, hPopupSettings, "Encrypt File On Save", %IDT_SaveEncrypted, %MF_Enabled
    Menu Add String, hPopupSettings, "Show Toolbar", %IDM_ShowToolbar, %MF_Enabled
    Menu Add String, hPopupSettings, "Show Tree", %IDT_ShowTree, %MF_Enabled
    Menu Add String, hPopupSettings, "Show Editor", %IDT_ShowEditor, %MF_Enabled
    Menu Add String, hPopupSettings, "-", %IDM_Sep, %MF_Enabled
    Menu Add String, hPopupSettings, "Online Update", %IDM_UpdateEXE, %MF_Enabled

    Menu New PopUp To hContextTB
    Menu Add String, hContextTB, "Copy",   %IDM_Copy,  %MF_Enabled
    Menu Add String, hContextTB, "Cut",    %IDM_Cut,  %MF_Enabled
    Menu Add String, hContextTB, "Paste",  %IDM_Paste,  %MF_Enabled
    Menu Add String, hContextTB, "Delete", %IDM_Delete,  %MF_Enabled
    Menu Add String, hContextTB, "-",      %IDM_Sep,  %MF_Enabled
    Menu Add String, hContextTB, "Apply",  %IDM_Apply,  %MF_Enabled
    Menu Add String, hContextTB, "-",      %IDM_Sep,  %MF_Enabled
    Menu Add String, hContextTB, "Open Selection As URL",  %IDM_OpenURL,  %MF_Enabled

    Menu New PopUp To hLVFile
    Menu Add String, hLVFile, "Open",  %IDT_Open,  %MF_Enabled
    Menu Add String, hLVFile, "New",  %IDT_New,  %MF_Enabled
    Menu Add String, hLVFile, "Save",  %IDT_Save,  %MF_Enabled
    Menu Add String, hLVFile, "SaveAs",  %IDT_SaveAs,  %MF_Enabled

    Menu New PopUp To hLVEdit
    Menu Add String, hLVEdit, "Edit",  %IDT_Edit,  %MF_Enabled
    Menu Add String, hLVEdit, "Add",  %IDT_Add,  %MF_Enabled
    Menu Add String, hLVEdit, "Apply",  %IDT_Apply,  %MF_Enabled
    Menu Add String, hLVEdit, "View",  %IDT_View,  %MF_Enabled
    Menu Add String, hLVEdit, "-",  %IDM_Sep,  %MF_Enabled
    Menu Add String, hLVEdit, "Delete",  %IDT_Delete,  %MF_Enabled

    Menu New PopUp To hLVAttach
    Menu Add String, hLVAttach, "Attach File",  %IDT_Attach,  %MF_Enabled
    Menu Add String, hLVAttach, "View Attachment",  %IDM_ViewAttachment,  %MF_Enabled
    Menu Add String, hLVAttach, "Remove Attachment",  %IDM_RemoveAttachment,  %MF_Enabled
    Menu Add String, hLVAttach, "Compact Attachment File",  %IDM_CompactAttachments,  %MF_Enabled

    Menu New PopUp To hLVSettings
    Menu Add String, hLVSettings, "Confirm Delete",  %IDM_ConfirmDelete,  %MF_Enabled
    Menu Add String, hLVSettings, "Auto Save on Exit",  %IDM_AutoSave,  %MF_Enabled
    Menu Add String, hLVSettings, "FileName in Title",  %IDM_FileIntitle,  %MF_Enabled
    Menu Add String, hLVSettings, "Double-Click To Edit", %IDM_ClickToEdit, %MF_Enabled
    Menu Add String, hLVSettings, "On Top", %IDM_OnTop, %MF_Enabled
    Menu Add String, hLVSettings, "Event Report On Startup", %IDM_AutoCheckEvents, %MF_Enabled
    Menu Add String, hLVSettings, "AutoUpdate From Editor", %IDM_AutoUpdateEditor, %MF_Enabled
    Menu Add String, hLVSettings, "Small Toolbar", %IDM_SmallToolbar, %MF_Enabled
    Menu Add String, hLVSettings, "Large Editor", %IDM_BigEditor, %MF_Enabled

    Menu New PopUp To hLVActions
    Menu Add String, hLVActions, "Copy Selected Record",  %IDT_Copy,  %MF_Enabled
    Menu Add String, hLVActions, "Copy All Records In List",  %IDT_CopyChecked,  %MF_Enabled
    Menu Add String, hLVActions, "Print Checked Records",  %IDT_Print,  %MF_Enabled
    Menu Add String, hLVActions, "Send Email",  %IDT_Email,  %MF_Enabled
    Menu Add String, hLVActions, "Send Text Msg",  %IDM_TextMsg,  %MF_Enabled
    Menu Add String, hLVActions, "Select Font",  %IDT_Font,  %MF_Enabled

    Menu New PopUp To hPopupListView
    Menu Add PopUp, hPopupListView, "File", hLVFile, %MF_Enabled
    Menu Add PopUp, hPopupListView, "Edit", hLVEdit, %MF_Enabled
    Menu Add PopUp, hPopupListView, "Attachments", hLVAttach, %MF_Enabled
    Menu Add PopUp, hPopupListView, "Settings", hLVSettings, %MF_Enabled
    Menu Add PopUp, hPopupListView, "Actions", hLVActions, %MF_Enabled
    Menu Add String, hPopupListView, "-",  %IDM_Sep,  %MF_Enabled
    Menu Add String, hPopupListView, "Check All",  %IDM_CheckAll,  %MF_Enabled
    Menu Add String, hPopupListView, "UnCheck All",  %IDM_UnCheckAll,  %MF_Enabled
    Menu Add String, hPopupListView, "-",  %IDM_Sep,  %MF_Enabled
    Menu Add String, hPopupListView, "Find",  %IDT_Find,  %MF_Enabled
    Menu Add String, hPopupListView, "-",  %IDM_Sep,  %MF_Enabled
    Menu Add String, hPopupListView, "Encrypt File On Save", %IDT_SaveEncrypted, %MF_Enabled
    Menu Add String, hPopupListView, "Show Toolbar", %IDM_ShowToolbar, %MF_Enabled
    Menu Add String, hPopupListView, "Show Tree", %IDT_ShowTree, %MF_Enabled
    Menu Add String, hPopupListView, "Show Editor", %IDT_ShowEditor, %MF_Enabled
    Menu Add String, hPopupListView, "-",  %IDM_Sep,  %MF_Enabled
    Menu Add String, hPopupListView, "Online Update", %IDM_UpdateEXE, %MF_Enabled

    Menu New PopUp To hPopupTreeView
    Menu Add PopUp, hPopupTreeView, "File", hLVFile, %MF_Enabled
    Menu Add PopUp, hPopupTreeView, "Edit", hLVEdit, %MF_Enabled
    Menu Add PopUp, hPopupTreeView, "Attachments", hLVAttach, %MF_Enabled
    Menu Add PopUp, hPopupTreeView, "Settings", hLVSettings, %MF_Enabled
    Menu Add PopUp, hPopupTreeView, "Actions", hLVActions, %MF_Enabled
    Menu Add String, hPopupTreeView, "-",  %IDM_Sep,  %MF_Enabled
    Menu Add String, hPopupTreeView, "Expand All Nodes", %IDM_ExpandNodes, %MF_Enabled
    Menu Add String, hPopupTreeView, "Collapse All Nodes", %IDM_CollapseNodes, %MF_Enabled
    Menu Add String, hPopupTreeView, "-",  %IDM_Sep,  %MF_Enabled
    Menu Add String, hPopupTreeView, "Find", %IDT_Find, %MF_Enabled
    Menu Add String, hPopupTreeView, "-", %IDM_Sep, %MF_Enabled
    Menu Add String, hPopupTreeView, "Encrypt File On Save", %IDT_SaveEncrypted, %MF_Enabled
    Menu Add String, hPopupTreeView, "Show Toolbar", %IDM_ShowToolbar, %MF_Enabled
    Menu Add String, hPopupTreeView, "Show Tree", %IDT_ShowTree, %MF_Enabled
    Menu Add String, hPopupTreeView, "Show Editor", %IDT_ShowEditor, %MF_Enabled
    Menu Add String, hPopupTreeView, "-",  %IDM_Sep,  %MF_Enabled
    Menu Add String, hPopupTreeView, "Online Update", %IDM_UpdateEXE, %MF_Enabled

    ImageList New Icon 16,16,24,2 To hImageListSort
    ImageList Add Icon hImageListSort, "xsortup"   '1
    ImageList Add Icon hImageListSort, "xsortdown" '2
End Sub

Sub SetMenus
   If Debug Then Txt.Print FuncName$
    'Toolbars
    If SmallToolbar = 0 Then
       Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_SaveEncrypted, %TBState_Checked * SaveEncrypted Or %TBState_Enabled
       Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_ShowTree, %TBState_Checked * ShowTree Or %TBState_Enabled
       Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_ShowEditor, %TBState_Checked * ShowEditor Or %TBState_Enabled
    End If

    'menus
    Menu Set State hPopupSettings, ByCmd %IDM_ConfirmDelete, ConfirmDelete * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupSettings, ByCmd %IDM_AutoSave, AutoSave * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupSettings, ByCmd %IDM_FileInTitle, FileInTitle * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupSettings, ByCmd %IDM_ClickToEdit, ClickToEdit * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupSettings, ByCmd %IDM_OnTop, OnTop * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupSettings, ByCmd %IDM_AutoUpdateEditor, AutoUpdateEditor * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupSettings, ByCmd %IDM_SmallToolbar, SmallToolbar * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupSettings, ByCmd %IDM_BigEditor, BigEditor * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupSettings, ByCmd %IDM_AutoCheckEvents, AutoCheckEvents * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupSettings, ByCmd %IDT_SaveEncrypted, SaveEncrypted * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupSettings, ByCmd %IDM_ShowToolbar, ShowToolbar * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupSettings, ByCmd %IDM_SmallToolbar, SmallToolbar * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupSettings, ByCmd %IDM_BigEditor, BigEditor * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupSettings, ByCmd %IDT_ShowEditor, ShowEditor * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupSettings, ByCmd %IDT_ShowTree, ShowTree * (%MFS_Checked Or %MFS_Enabled)

    Menu Set State hPopupTreeView, ByCmd %IDT_SaveEncrypted, SaveEncrypted * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupTreeView, ByCmd %IDM_ShowToolbar, ShowToolbar * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupTreeView, ByCmd %IDM_SmallToolbar, SmallToolbar * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupTreeView, ByCmd %IDM_BigEditor, BigEditor * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupTreeView, ByCmd %IDT_ShowEditor, ShowEditor * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupTreeView, ByCmd %IDT_ShowTree, ShowTree * (%MFS_Checked Or %MFS_Enabled)

    Menu Set State hPopupListView, ByCmd %IDT_SaveEncrypted, SaveEncrypted * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupListView, ByCmd %IDM_ShowToolbar, ShowToolbar * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupListView, ByCmd %IDM_SmallToolbar, SmallToolbar * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupListView, ByCmd %IDM_BigEditor, BigEditor * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupListView, ByCmd %IDT_ShowTree, ShowTree * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupListView, ByCmd %IDT_ShowEditor, ShowEditor * (%MFS_Checked Or %MFS_Enabled)

    Menu Set State hLVSettings, ByCmd %IDM_ConfirmDelete, ConfirmDelete * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hLVSettings, ByCmd %IDM_AutoSave, AutoSave * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hLVSettings, ByCmd %IDM_ClickToEdit, ClickToEdit * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hLVSettings, ByCmd %IDM_FileInTitle, FileInTitle * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hLVSettings, ByCmd %IDM_OnTop, OnTop * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hLVSettings, ByCmd %IDM_AutoUpdateEditor, AutoUpdateEditor * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hLVSettings, ByCmd %IDM_SmallToolbar, SmallToolbar * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hLVSettings, ByCmd %IDM_BigEditor, BigEditor * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hLVSettings, ByCmd %IDM_AutoCheckEvents, AutoCheckEvents * (%MFS_Checked Or %MFS_Enabled)

End Sub

Sub FakeData
   If Debug Then Txt.Print FuncName$
   Local i As Long, temp$
   If MsgBoxX("Build sample data (will overwrite existing content)?", %MB_OkCancel + %MB_IconQuestion, "Build Sample Data") = %IdCancel Then Exit Sub

   Select Case MsgBoxX("Build small sample database?",%MB_YesNoCancel + %MB_IconQuestion, "Build Fake DataBase")
      Case %IdNo
         ListView Reset hDlg, %IDC_ListView
         ReDim D(0 To 1000)
         D(0).name = "-"
         D(0).phone = "-"
         D(0).email = "-"
         D(0).company = "-"
         D(0).msg = "-"
         D(0).loc = "-"
         D(0).country = "-"
         D(0).category = "-"
         D(0).flag = "-"
         D(0).node = "-"
         D(0).bname = "-"
         D(0).bstart = "-"
         D(0).bend = "-"
         D(0).unusedA = "-"
         D(0).unusedB = "-"
         D(0).unusedC = "-"
         D(0).events = "-"
         D(0).date = "-"
         D(0).blog = "-"

         For i = 1 To 1000
            D(i).name = "Name " + Format$(Rnd(1,1000),"000")
            D(i).phone = "Phone " + Format$(Rnd(1,1000),"000")
            D(i).email = "Email " + Format$(Rnd(1,1000),"000")
            D(i).company = "Company " + Format$(Rnd(1,1000),"000")
            D(i).msg = "Msg " + Format$(Rnd(1,10),"00")
            D(i).loc = "Location " + Format$(Rnd(1,500),"000")
            D(i).country = "Country " + Format$(Rnd(1,100),"000")
            D(i).category = "Category " + Format$(Rnd(1,10),"00")
            D(i).flag = "1"
            D(i).node = "-"
            D(i).bname = "-"
            D(i).bstart = "-"
            D(i).bend = "-"
            D(i).unusedA = "-"
            D(i).unusedB = "-"
            D(i).unusedC = "-"
            D(i).events = "Bday " + Format$(Rnd(1,12),"00")+"-"+Format$(Rnd(1,28),"00")+"-1990"
            D(i).date = CDate
            D(i).blog = "Blog " + Format$(Rnd(1,1000),"000")
         Next i
      Case %IdYes
         ListView Reset hDlg, %IDC_ListView
         ReDim D(0 To 6)
         D(0).name = "-" : D(0).loc = "-" : D(0).country = "-" : D(0).flag = "-"
         D(0).date = "-" : D(0).category = "-" : D(0).bstart = "-" : D(0).bend = "-"
         D(0).phone = "-" : D(0).email = "-" : D(0).node = "-"
         D(0).date = "-" : D(0).bname = "-"
         D(0).blog = "-" : D(0).events = "-"
         D(0).msg = "-"  : D(0).company = "-"
         D(0).unusedA = "-" : D(0).unusedB = "-" : D(0).unusedC = "-"

         D(1).name = "John Gleason" : D(1).loc = "Michigan" : D(1).country = "USA"
         D(1).flag = "1" : D(1).category = "Friend" : D(1).bstart = "-" : D(1).bend = "-"
         D(1).phone = "862-444-0133" : D(1).email = "john@usa.com" : D(1).node = "-"
         D(1).date = "2012-11-25 10:29:00" : D(1).bname = "-"
         D(1).blog = "A cold country where" + $CrLf + "WereWolves reign (well" + $CrLf + "known football team)!"
         D(1).events = "BDay 12-06-1947"
         D(1).msg = "ATT"  : D(1).company = "Silver Logos"
         D(1).unusedA = "-" : D(1).unusedB = "-" : D(1).unusedC = "-"

         D(2).name = "Gary Beene" : D(2).loc = "Dallas, Tx" : D(2).country = "USA"
         D(2).flag = "1" : D(2).category = "Family" : D(2).bstart = "-" : D(2).bend = "-"
         D(2).phone = "214-668-9913" : D(2).email = "gbeene@airmail.net" : D(2).node = "-"
         D(2).date = "2012-11-25 10:10:00" : D(2).bname = "-"
         D(2).blog = "Home of the Dallas" + $CrLf + "Cowboys, whose stadium" + $CrLf + "is, strangely enough, not" + $CrLf + "in Dallas!" + $CrLf + "http://www.garybeene.com"
         D(2).events = "BDay 09-12-1951"
         D(2).msg = "ATT"  : D(2).company = "Raytheon"
         D(2).unusedA = "-" : D(2).unusedB = "-" : D(2).unusedC = "-"

         D(3).name = "Chris Holbrook" : D(3).loc = "London, England" : D(3).country = "UK"
         D(3).flag = "1" : D(3).category = "Friend" : D(3).bstart = "-" : D(3).bend = "-"
         D(3).phone = "44-263-7777" : D(3).email = "holbrook@uk.com" : D(3).node = "-"
         D(3).date = "2012-11-25 10:40:00" : D(3).bname = "-"
         D(3).blog = "Only major country in the" + $CrLf + "world with a ferris wheel" + $CrLf + "as a major attraction!"
         D(3).events = "BDay 12-01-1954"
         D(3).msg = "Sprint"  : D(3).company = "QueenCoders"
         D(3).unusedA = "-" : D(3).unusedB = "-" : D(3).unusedC = "-"

         D(4).name = "Jose Roca" : D(4).loc = "Valencia" : D(4).country = "Spain"
         D(4).flag = "1" : D(4).category = "Family" : D(4).bstart = "-" : D(4).bend = "-"
         D(4).phone = "33-062-8771" : D(4).email = "bullrunner@spain.com" : D(4).node = "-"
         D(4).date = "2012-11-25 10:45:00" : D(4).bname = "-"
         D(4).blog = "I've never understood the" + $CrLf + "bull running thing. I much" + $CrLf + "prefer the US rattlesnake" + $CrLf + "hunts!"
         D(4).events = "BDay 08-16-1948"
         D(4).msg = "Sprint"  : D(4).company = "Lone Coder, Inc."
         D(4).unusedA = "-" : D(4).unusedB = "-" : D(4).unusedC = "-"

         D(5).name = "Patrice Terrier" : D(5).loc = "Paris" : D(5).country = "France"
         D(5).flag = "1" : D(5).category = "Co-Worker" : D(5).bstart = "-" : D(5).bend = "-"
         D(5).phone = "14-233-8192" : D(5).email = "graphicman@france.com" : D(5).node = "-"
         D(5).date = "2012-11-25 10:05:00" : D(5).bname = "-"
         D(5).blog = "The language of love is " + $CrLf + "spoken there, yes? On" + $CrLf + "everyone's travel list!"
         D(5).events = "BDay 12-02-1950"
         D(5).msg = "Verizon"  : D(5).company = "Better Graphics"
         D(5).unusedA = "-" : D(5).unusedB = "-" : D(5).unusedC = "-"

         D(6).name = "Dave Biggs" : D(6).loc = "Sydney" : D(6).country = "Australia"
         D(6).flag = "1" : D(6).category = "Co-Worker" : D(6).bstart = "-" : D(6).bend = "-"
         D(6).phone = "07-331-881" : D(6).email = "biggs@outback.com" : D(6).node = "-"
         D(6).date = "2012-11-25 04:05:00" : D(6).bname = "-"
         D(6).blog = "Ever since Opra went" + $CrLf + "down under, the country" + $CrLf + "has reached a new level" + $CrLf + "of fame!"
         D(6).events = "BDay 12-04-1958"
         D(6).msg = "TMobile"  : D(6).company = "Best Western Hotels"
         D(6).unusedA = "-" : D(6).unusedB = "-" : D(6).unusedC = "-"
      Case %IdCancel
         Exit Sub
   End Select
   'use the array
   Array Sort D(1)
   LoadListViewFromD
   If ShowTree Then LoadTreeViewFromLV : SelectTVFromLV
   If ShowEditor Then LoadTextBoxFromD
   FileChanged = 1
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Save, IIf(FileChanged,%TBState_Enabled,%TBState_Disabled)
End Sub

Sub DisplayFindDialog()
   If Debug Then Txt.Print FuncName$
   Local w,h As Long
   Dialog Get Client hDlg To h,w
   Dialog New Pixels, hDlg, "Find", 100, 100, 330, 85, %WS_SysMenu Or %WS_Caption Or %WS_ClipChildren To hSearch
   Dialog Set Icon hSearch, "xsearch"
   Control Add Label, hSearch, %IDS_Label, "Find This:", 5, 10, 60, 20, %SS_Notify
   Control Add TextBox, hSearch, %IDS_SearchTerm, SearchTerm, 65, 10, 180, 20
   Control Add CheckBox, hSearch, %IDS_Case, "Case Sensitive", 10, 35, 125, 25
   Control Set Check hSearch, %IDS_Case, CaseSensitive
   Control Add CheckBox, hSearch, %IDS_WholeWord, "Whole Word", 10, 55, 125, 25
   Control Set Check hSearch, %IDS_WholeWord, WholeWords
   Control Add Option, hSearch, %IDS_AND, "AND", 140, 45, 50,25
   Control Add Option, hSearch, %IDS_OR, "OR", 190, 45, 40,25
   Control Add Option, hSearch, %IDS_STRING, "String", 240, 45, 60,25
   Control Add Button, hSearch, %IDS_Search, "Search", 260, 10, 56, 25
   Dialog Show Modeless hSearch Call SearchProc()
   Do                                                                    'because we want to be able
      Dialog DoEvents                                                     'to edit main text while
   Loop While IsWindow(hSearch)
End Sub

CallBack Function SearchProc() As Long
   Local iResult As Long
   Select Case Cb.Msg
      Case %WM_InitDialog
         Select Case SearchMode
            Case %SearchAsString : Control Set Option hSearch, %IDS_STRING, %IDS_STRING, %IDS_OR
            Case %SearchAllTerms : Control Set Option hSearch, %IDS_AND, %IDS_STRING, %IDS_OR
            Case %SearchAnyTerm  : Control Set Option hSearch, %IDS_OR, %IDS_STRING, %IDS_OR
         End Select
         Control Set Font hSearch, %IDS_Label, hFontA
         Control Set Font hSearch, %IDS_Case, hFontA
         Control Set Font hSearch, %IDS_WholeWord, hFontA
         Control Set Font hSearch, %IDS_SearchTerm, hFontA
         Control Set Font hSearch, %IDS_Search, hFontA
         Control Set Font hSearch, %IDS_AND, hFontA
         Control Set Font hSearch, %IDS_OR, hFontA
         Control Set Font hSearch, %IDS_STRING, hFontA
      Case %WM_SYSCOMMAND
         If (Cb.WParam And &HFFF0) = %SC_Close Then          'trap Alt-F4 and X Button
            Control Set Focus hDlg, %IDC_ListView
         End If
      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDS_Search
               FindSearchTerm
            Case %IdOk
               FindSearchTerm
            Case %IdCancel
               Dialog End hSearch
            Case %IDS_Label
               If Cb.CtlMsg = %STN_DblClk Then ViewAllRecords
         End Select
      Case %WM_Destroy
         Control Get Check hSearch, %IDS_Case To CaseSensitive
         Control Get Check hSearch, %IDS_WholeWord To WholeWords
         Control Get Check hSearch, %IDS_STRING To iResult : If iResult Then SearchMode = %SearchAsString
         Control Get Check hSearch, %IDS_AND To iResult    : If iResult Then SearchMode = %SearchAllTerms
         Control Get Check hSearch, %IDS_OR To iResult     : If iResult Then SearchMode = %SearchAnyTerm
         Dialog Post hDlg, %WM_User+501, 0, 0
   End Select
End Function

Sub ViewAllRecords
   If Debug Then Txt.Print FuncName$
   Local iPos As Long
   For iPos = 1 To UBound(D) :
      If D(iPos).Flag <> "1" Then
         D(iPos).flag = "1"
         FileChanged = 1
         Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Save, IIf(FileChanged,%TBState_Enabled,%TBState_Disabled)
      End If
   Next iPos
   LoadListViewFromD
   If ShowTree Then LoadTreeViewFromLV : SelectTVFromLV
   If ShowEditor Then LoadTextBoxFromD
End Sub

Function RecordText(iPos As Long, DLimiter As String) As String
   If Debug Then Txt.Print FuncName$
   Local temp$
   If Len(Trim$(D(iPos).name))      Then temp$ = temp$ + Trim$(D(iPos).name)
   If Len(Trim$(D(iPos).phone))     Then temp$ = temp$ + DLimiter + Trim$(D(iPos).phone)
   If Len(Trim$(D(iPos).email))     Then temp$ = temp$ + DLimiter + Trim$(D(iPos).email)
   If Len(Trim$(D(iPos).company))   Then temp$ = temp$ + DLimiter + Trim$(D(iPos).company)
   If Len(Trim$(D(iPos).msg))       Then temp$ = temp$ + DLimiter + Trim$(D(iPos).msg)
   If Len(Trim$(D(iPos).loc))       Then temp$ = temp$ + DLimiter + Trim$(D(iPos).loc)
   If Len(Trim$(D(iPos).country))   Then temp$ = temp$ + DLimiter + Trim$(D(iPos).country)
   If Len(Trim$(D(iPos).category))  Then temp$ = temp$ + DLimiter + Trim$(D(iPos).category)
   If Len(Trim$(D(iPos).events))    Then temp$ = temp$ + DLimiter + Trim$(D(iPos).events)
   If Len(Trim$(D(iPos).date))      Then temp$ = temp$ + DLimiter + Trim$(D(iPos).date)
   temp$ = temp$ + DLimiter + Trim$(Str$(iPos))
   Function = temp$
End Function

Function RecordTextV(iPos As Long) As String
   If Debug Then Txt.Print FuncName$
   Local temp$
   If Len(Trim$(D(iPos).name))     Then temp$ = temp$ + Trim$(D(iPos).name)
   If Len(Trim$(D(iPos).phone))    Then temp$ = temp$ + $CrLf + Trim$(D(iPos).phone)
   If Len(Trim$(D(iPos).email))    Then temp$ = temp$ + $CrLf + Trim$(D(iPos).email)
   If Len(Trim$(D(iPos).company))  Then temp$ = temp$ + $CrLf + Trim$(D(iPos).company)
   If Len(Trim$(D(iPos).msg))      Then temp$ = temp$ + $CrLf + Trim$(D(iPos).msg)
   If Len(Trim$(D(iPos).loc))      Then temp$ = temp$ + $CrLf + Trim$(D(iPos).loc)
   If Len(Trim$(D(iPos).country))  Then temp$ = temp$ + $CrLf + Trim$(D(iPos).country)
   If Len(Trim$(D(iPos).category)) Then temp$ = temp$ + $CrLf + Trim$(D(iPos).category)
   If Len(Trim$(D(iPos).events))   Then temp$ = temp$ + $CrLf + Trim$(D(iPos).events)
   If Len(Trim$(D(iPos).blog))     Then temp$ = temp$ + $CrLf + Trim$(D(iPos).blog)
   If Len(Trim$(D(iPos).date))     Then temp$ = temp$ + $CrLf + Trim$(D(iPos).date)
   Function = temp$
End Function

Sub CheckAll
   If Debug Then Txt.Print FuncName$
   Local i,iResult As Long
   ListView Get Count hDlg, %IDC_ListView To iResult
   For i = 1 To iResult
     ListView_SetCheckState hListView, i-1, %True
   Next i
End Sub

Sub UnCheckAll
   If Debug Then Txt.Print FuncName$
   Local i,iResult As Long
   ListView Get Count hDlg, %IDC_ListView To iResult
   For i = 1 To iResult
     ListView_SetCheckState hListView, i-1, %False
   Next i
End Sub

Sub CreateListView
   If Debug Then Txt.Print FuncName$

   Control Add ListView, hDlg, %IDC_ListView,"", 220,60,315,250,  %WS_Child Or %WS_TabStop Or %WS_Visible Or %LVS_ShowSelAlways Or %LVS_Report Or %LVS_ShowSelAlways Or %LVS_SingleSel, %WS_Ex_ClientEdge
   Control Handle hDlg, %IDC_ListView To hListView
   ListView Set StyleXX hDlg, %IDC_ListView, %LVS_Ex_CheckBoxes Or %LVS_Ex_GridLines Or %LVS_Ex_FullRowSelect 'Or %LVS_Ex_DoubleBuffer
   ListView Insert Column hDlg, %IDC_ListView, 1,  Title1,  wCol1,  0   'name
   ListView Insert Column hDlg, %IDC_ListView, 2,  Title2,  wCol2,  0   'phone
   ListView Insert Column hDlg, %IDC_ListView, 3,  Title3,  wCol3,  0   'email
   ListView Insert Column hDlg, %IDC_ListView, 4,  Title4,  wCol4,  0   'company
   ListView Insert Column hDlg, %IDC_ListView, 5,  Title5,  wCol5,  0   'msg
   ListView Insert Column hDlg, %IDC_ListView, 6,  Title6,  wCol6,  0   'loc
   ListView Insert Column hDlg, %IDC_ListView, 7,  Title7,  wCol7,  0   'country
   ListView Insert Column hDlg, %IDC_ListView, 8,  Title8,  wCol8,  0   'category
   ListView Insert Column hDlg, %IDC_ListView, 9,  Title9,  wCol9,  0   'date
   ListView Insert Column hDlg, %IDC_ListView, 10,  Title10,  wCol1, 0   'attachment
   ListView Insert Column hDlg, %IDC_ListView, 11, Title11, wCol11, 0   'events
   ListView Insert Column hDlg, %IDC_ListView, 12, Title12, wCol12, 0   'pos
   ListView Insert Column hDlg, %IDC_ListView, 13, Title13, wCol13, 0   'node
   SendMessage (hListView, %WM_NOTIFYFORMAT, hDlg, %NF_REQUERY)

   'assign imagelist to header
   hHeader = ListView_GetHeader(hListView)
   Header_SetImageList hHeader, hImagelistSort
End Sub

Function CDate() As String
   If Debug Then Txt.Print FuncName$
   Local temp$
   temp$ = Date$
   Function = Mid$(temp$, 7 To 10) + "-" + Left$(temp$,5) + $Spc + Time$
End Function

Sub SetDialogTitle
   If Debug Then Txt.Print FuncName$
   If FileInTitle=1 Then Dialog Set Text hDlg, "gbTextDB " + $ver + Space$(9) + PathName$(Namex,FileName)
   If FileInTitle=0 Then Dialog Set Text hDlg, "gbTextDB " + $ver
End Sub

Function RecordTextB(B As BohoData) As String
   If Debug Then Txt.Print FuncName$
   Local temp$
   temp$ = temp$ + Trim$(B.name)
   temp$ = temp$ + $CrLf + Trim$(B.phone)
   temp$ = temp$ + $CrLf + Trim$(B.email)
   temp$ = temp$ + $CrLf + Trim$(B.company)
   temp$ = temp$ + $CrLf + Trim$(B.msg)
   temp$ = temp$ + $CrLf + Trim$(B.loc)
   temp$ = temp$ + $CrLf + Trim$(B.country)
   temp$ = temp$ + $CrLf + Trim$(B.category)
   temp$ = temp$ + $CrLf + Trim$(B.events)
   temp$ = temp$ + $CrLf + Trim$(B.bname)
   temp$ = temp$ + $CrLf + Trim$(B.bstart)
   temp$ = temp$ + $CrLf + Trim$(B.bend)
   temp$ = temp$ + $CrLf + Trim$(B.date)
   temp$ = temp$ + $CrLf + Trim$(B.flag)
   temp$ = temp$ + $CrLf + Trim$(B.blog)
   Function = temp$
End Function


Sub FillListViewRow(iPos As Long, iRow As Long)
   If Debug Then Txt.Print FuncName$
   ListView Set Text hDlg, %IDC_ListView, iRow, 1, Trim$(D(iPos).name)
   ListView Set Text hDlg, %IDC_ListView, iRow, 2, Trim$(D(iPos).phone)
   ListView Set Text hDlg, %IDC_ListView, iRow, 3, Trim$(D(iPos).email)
   ListView Set Text hDlg, %IDC_ListView, iRow, 4, Trim$(D(iPos).company)
   ListView Set Text hDlg, %IDC_ListView, iRow, 5, Trim$(D(iPos).msg)
   ListView Set Text hDlg, %IDC_ListView, iRow, 6, Trim$(D(iPos).loc)
   ListView Set Text hDlg, %IDC_ListView, iRow, 7, Trim$(D(iPos).country)
   ListView Set Text hDlg, %IDC_ListView, iRow, 8, Trim$(D(iPos).category)
   ListView Set Text hDlg, %IDC_ListView, iRow, 9, Trim$(D(iPos).date)
   ListView Set Text hDlg, %IDC_ListView, iRow, 10, Trim$(D(iPos).bname)
   ListView Set Text hDlg, %IDC_ListView, iRow, 11, Trim$(D(iPos).events)
   ListView Set Text hDlg, %IDC_ListView, iRow, 12, Trim$(Str$(iPos))
'   ListView Set Text hDlg, %IDC_ListView, iRow, 11, Trim$(D(iPos).node)
End Sub

Sub CreateTreeView
   If Debug Then Txt.Print FuncName$
   Control Add Treeview, hDlg, %IDC_TreeView, "",  10, 60, 150, 250, %TVS_TrackSelect Or %TVS_HasLines Or %TVS_HasButtons Or %TVS_LinesAtRoot _
       Or %TVS_ShowSelAlways Or %WS_TabStop, %WS_Ex_ClientEdge Or %WS_Ex_Left 'Or %WS_Ex_AcceptFiles
'       Or %TVS_ShowSelAlways Or %WS_TabStop Or %TVS_EditLabels, %WS_Ex_ClientEdge Or %WS_Ex_Left 'Or %WS_Ex_AcceptFiles
   Control Handle hDlg, %IDC_TreeView To hTree
End Sub

Sub CollapseAllNodes
   If Debug Then Txt.Print FuncName$
   Local hNode As Dword
   Treeview Get Child hDlg, %IDC_TreeView,0 To hNode
   Do While hNode
      Treeview Set Expanded hDlg, %IDC_TreeView, hNode, %False
      Treeview Get Next hDlg, %IDC_TreeView, hNode To hNode
   Loop
End Sub

Sub ExpandAllNodes
   If Debug Then Txt.Print FuncName$
   Local hNode As Dword
   Treeview Get Child hDlg, %IDC_TreeView,0 To hNode
   Do While hNode
      Treeview Set Expanded hDlg, %IDC_TreeView, hNode, %True
      Treeview Get Next hDlg, %IDC_TreeView, hNode To hNode
   Loop
End Sub

Sub CopyNode
   If Debug Then Txt.Print FuncName$
   Local hNode,hTemp As Dword, iPos As Long
   Treeview Get Select hDlg, %IDC_TreeView To hNode
   Treeview Get Parent hDlg, %IDC_TreeView, hNode To hTemp
   If hTemp Then
      iPos = ArrayPositionFromNode(hTemp)
      Clipboard Reset
      Clipboard Set Text RecordTextV(iPos)
   End If
End Sub

Function ArrayPositionFromNode(hNode As Dword) As Long
   If Debug Then Txt.Print FuncName$
   Local iCount,iPos As Long, temp$, fName$
   fName$ = SelectFileToSaveAs("Save As", %OFN_PathMustExist Or %OFN_Explorer Or %OFN_OverWritePrompt, Chr$("CSV",0,"*.csv",0))
   If Len(fName$) Then
      Open fName$ For Output As #1
      ListView Get Count hDlg, %IDC_ListView To iCount
      For iPos = 1 To iCount
         ListView Get Text hDlg, %IDC_ListView, iPos, 12 To temp$  'array POS
         If Val(temp$) = hNode Then
            ListView Get Text hDlg, %IDC_ListView, iPos, 13 To temp$  'TreeView node
            Function = Val(temp$)
            Exit Function
         End If
      Next i
      Close #1
   End If
End Function

Sub ExportCSVAll
   If Debug Then Txt.Print FuncName$
   Local iPos As Long, temp$, fName$
   fName$ = SelectFileToSaveAs("Save As", %OFN_PathMustExist Or %OFN_Explorer Or %OFN_OverWritePrompt, Chr$("CSV",0,"*.csv",0))
   If Len(fName$) Then
      Open fName$ For Output As #1
      For iPos = 1 To UBound(D)
         temp$ = D(iPos).name
         Replace $Dq With $Dq + $Dq In temp$
         If iPos < UBound(D) Then
            Print #1, $Dq + temp$ + $Dq + "," ;
         Else
            Print #1, $Dq + temp$ + $Dq
         End If
      Next i
      Close #1
   End If
End Sub

Sub ExportCSVVisible
   'record is one line
   'command separates field
   'field enclosed with $DQ, even if multi-line
   If Debug Then Txt.Print FuncName$
   Local iPos, iCount As Long, temp$
   ListView Get Count hDlg, %IDC_ListView To iCount
   Open FileName + ".csv" For Output As #1
   For iPos = 1 To iCount
      ListView Get Text hDlg, %IDC_ListView, iPos, 12 To temp$   'array pos
      iPos = Val(temp$)
      temp$ = D(iPos).name
      Replace $Dq With $Dq + $Dq In temp$
      If iPos < iCount Then
         Print #1, $Dq + temp$ + $Dq + "," ;
      Else
         Print #1, $Dq + temp$ + $Dq
      End If
   Next i
   Close #1
End Sub

Sub DisplayRecordDialog (Title As String, Flag As Long, iPos As Long, iSelect As Long)
   If Debug Then Txt.Print FuncName$
   Local hRecord As Dword, i,Style As Long
   Static RecCount As Dword
'   Style = %WS_Child Or %WS_Visible Or %ES_MultiLine Or %WS_VScroll Or %ES_AutoHScroll _
'      Or %WS_HScroll Or %ES_AutoVScroll Or %ES_WantReturn Or %ES_NoHideSel Or %WS_TabStop
'   Style = %ES_MultiLine Or %ES_WantReturn Or %WS_TabStop
   Style = %WS_Child Or %WS_Visible Or %ES_MultiLine _ ' Or %ES_AutoHScroll _
      Or %ES_WantReturn Or %ES_NoHideSel Or %WS_TabStop  'Or %WS_HScroll


   Dialog New Pixels, hDlg, Title, 100, 100, 470, 290, %WS_SysMenu Or %WS_Caption Or %WS_ClipChildren To hRecord
   Dialog Set Icon hRecord, "logo"
   Control Add Label, hRecord, %IDR_NameL, Title1+":" , 10, 12, 50, 20
   Control Add Label, hRecord, %IDR_PhoneL, Title2+":" , 10, 42, 50, 20
   Control Add Label, hRecord, %IDR_EmailL, Title3+":" , 10, 72, 50, 20
   Control Add Label, hRecord, %IDR_CompanyL, Title4+":" , 10, 102, 57, 20
   Control Add Label, hRecord, %IDR_MsgL, Title5+":" , 10, 132, 57, 20
   Control Add Label, hRecord, %IDR_LocL, Title6+":" , 10, 162, 50, 20
   Control Add Label, hRecord, %IDR_CountryL, Title7+":" , 10, 192, 60, 20
   Control Add Label, hRecord, %IDR_CategoryL, Title8+":" , 10, 222, 60, 20
   Control Add Label, hRecord, %IDR_EventsL, Title11+":" , 10, 252, 60, 20

   'put incoming record data into the controls
   Control Add TextBox, hRecord, %IDR_Name, Trim$(D(iPos).name) , 70, 10, 185, 20
   Control Add TextBox, hRecord, %IDR_Phone, Trim$(D(iPos).phone) , 70, 40, 185, 20
   Control Add TextBox, hRecord, %IDR_email, Trim$(D(iPos).email) , 70, 70, 185, 20
   Control Add TextBox, hRecord, %IDR_company, Trim$(D(iPos).company) , 70, 100, 185, 20
   Control Add TextBox, hRecord, %IDR_msg, Trim$(D(iPos).msg) , 70, 130, 185, 20
   Control Add TextBox, hRecord, %IDR_Loc, Trim$(D(iPos).loc) , 70, 160, 185, 20
   Control Add TextBox, hRecord, %IDR_Country, Trim$(D(iPos).country) , 70, 190, 185, 20
   Control Add TextBox, hRecord, %IDR_Category, Trim$(D(iPos).category) , 70, 220, 185, 20
   Control Add TextBox, hRecord, %IDR_Events, Trim$(D(iPos).events) , 70, 250, 185, 20

   Control Add Label, hRecord, %IDR_blogL, Title12+":" , 270, 10, 40, 20
   Control Add TextBox, hRecord, %IDR_blog, Trim$(D(iPos).blog) , 270, 30, 185, 110, Style, %WS_Ex_ClientEdge
   Control Add Button, hRecord, %IDR_Copy, "Copy" , 280, 160, 50, 30
   Control Add Button, hRecord, %IDR_SaveExit, "Save" , 340, 160, 50, 30
   If Flag = %ViewRecord Then Control Disable hRecord, %IDR_SaveExit
   Control Add Button, hRecord, %IDR_Cancel, "Cancel" , 400, 160, 50, 30

   'set all label/text controls to hFontA
   For i = %IDR_Name To %IDR_BlogL : Control Set Font hRecord, i, hFontA : Next i

   'store incoming arguments in the DlgData() array
   Incr RecCount
   ReDim Preserve DlgData(RecCount)
   DlgData(RecCount).hWin = hRecord          'new dialog handle
   DlgData(RecCount).Flag = Flag             'incoming argument to Function
   DlgData(RecCount).iPos = iPos             'incoming argument to Function
   DlgData(RecCount).iSelect = iSelect       'incoming argument to Function
   Dialog Set User hRecord, 1, RecCount

   'store record to be editing DlgData() array .Input
   Select Case Flag
      Case %AddRecord
         DlgData(RecCount).Input = D(0)   'D(0) has the default values
         DlgData(RecCount).Output = D(0)
      Case %ViewRecord
         For i = %IDR_Name To %IDR_Blog : Control Disable hRecord, i : Next i
      Case %EditRecord
         DlgData(RecCount).Input = D(iPos)
         DlgData(RecCount).Output = D(iPos)
   End Select

   'display dialog
   If Flag = %ViewRecord Then
      'show as many as you want
      Dialog Show Modeless hRecord Call RecordProc()
   Else
      'show only 1 if task is to Edit or Add a record
      Dialog Show Modal hRecord Call RecordProc()
   End If
End Sub

CallBack Function RecordProc() As Long
   Local RecCount As Long, temp$, tmp$
   Select Case Cb.Msg
      Case %WM_Command
         Select Case Cb.Ctl
            Case %IdOk
               'pressing ENTER will essentially TAB from one control to the next
               Select Case GetFocus
                  Case GetDlgItem(Cb.Hndl, %IDR_Name)    : Control Set Focus Cb.Hndl, %IDR_Phone
                  Case GetDlgItem(Cb.Hndl, %IDR_Phone)   : Control Set Focus Cb.Hndl, %IDR_Email
                  Case GetDlgItem(Cb.Hndl, %IDR_Email)   : Control Set Focus Cb.Hndl, %IDR_Company
                  Case GetDlgItem(Cb.Hndl, %IDR_Company) : Control Set Focus Cb.Hndl, %IDR_Company
                  Case GetDlgItem(Cb.Hndl, %IDR_Loc)     : Control Set Focus Cb.Hndl, %IDR_Country
                  Case GetDlgItem(Cb.Hndl, %IDR_Country) : Control Set Focus Cb.Hndl, %IDR_Category
                  Case GetDlgItem(Cb.Hndl, %IDR_Category): Control Set Focus Cb.Hndl, %IDR_Events
                  Case GetDlgItem(Cb.Hndl, %IDR_Events)  : Control Set Focus Cb.Hndl, %IDR_Blog
                  Case GetDlgItem(Cb.Hndl, %IDR_Blog)    : Control Set Focus Cb.Hndl, %IDR_Name
               End Select
            Case %IdCancel, %IDR_Cancel
               Dialog End Cb.Hndl
            Case %IDR_SaveExit
               Dialog Get User Cb.Hndl, 1 To RecCount
               GetRecordDialogOutput Cb.Hndl, RecCount
               SaveRecordDialogOutput RecCount
               Dialog End Cb.Hndl
            Case %IDR_Copy
               Control Get Text Cb.Hndl, %IDR_Name To tmp$
               Control Get Text Cb.Hndl, %IDR_Phone To temp$    : tmp$ = tmp$ + $CrLf + temp$
               Control Get Text Cb.Hndl, %IDR_Email To temp$    : tmp$ = tmp$ + $CrLf + temp$
               Control Get Text Cb.Hndl, %IDR_Company To temp$  : tmp$ = tmp$ + $CrLf + temp$
               Control Get Text Cb.Hndl, %IDR_Loc To temp$      : tmp$ = tmp$ + $CrLf + temp$
               Control Get Text Cb.Hndl, %IDR_Country To temp$  : tmp$ = tmp$ + $CrLf + temp$
               Control Get Text Cb.Hndl, %IDR_Category To temp$ : tmp$ = tmp$ + $CrLf + temp$
               Control Get Text Cb.Hndl, %IDR_Events To temp$   : tmp$ = tmp$ + $CrLf + temp$
               Control Get Text Cb.Hndl, %IDR_Blog To temp$     : tmp$ = tmp$ + $CrLf + temp$
               Clipboard Reset
               Clipboard Set Text tmp$
         End Select
      Case %WM_SYSCOMMAND
         If (Cb.WParam And &HFFF0) = %SC_Close Then    'trap Alt-F4, X-button, WindowMenu/Close
            Dialog Get User Cb.Hndl, 1 To RecCount
            If DlgData(RecCount).Flag <> %ViewRecord Then  'only applies to Edit or Add
               GetRecordDialogOutput Cb.Hndl, RecCount     'read user inputs
               If DlgData(RecCount).Output <> DlgData(RecCount).Input Then  'do nothing if INPUT = OUTPUT
                  'if changes, give user option to save/ignore/abort
                  Select Case MsgBoxX("Changes were made. Save changes?", %MB_YesNoCancel + %MB_IconQuestion + %MB_TaskModal, "Close Record Dialog")
                     Case %IdYes
                        SaveRecordDialogOutput RecCount
                        Function = 0    'close after having saved changes
                     Case %IdNo
                        Function = 0    'no action. close without saving changes
                     Case %IdCancel
                        Function = 1    'abort close - return to application
                  End Select
               End If
            End If
         End If
      Case %WM_Destroy
         'Figure out which dialog we're dealing with (which position in the array represents the current dialog)
         Dialog Get User Cb.Hndl, 1 To RecCount
         If DlgData(RecCount).Flag = %AddRecord Then AddRecordDisplay = 0    'to allow a new Add Record dialog
         If DlgData(RecCount).Flag = %EditRecord Then EditRecordDisplay = 0  'to allow a new Edit Record dialog
         Dialog Post hDlg, %WM_User+501, 0, 0
   End Select
End Function

Sub GetRecordDialogOutput(hWin As Dword, RecCount As Long)
   Local temp$
   'get values from controls
   Control Get Text hWin, %IDR_Name To temp$     : DlgData(RecCount).Output.Name = Trim$(temp$)
   Control Get Text hWin, %IDR_Phone To temp$    : DlgData(RecCount).Output.Phone = Trim$(temp$)
   Control Get Text hWin, %IDR_Email To temp$    : DlgData(RecCount).Output.Email = Trim$(temp$)
   Control Get Text hWin, %IDR_Company To temp$  : DlgData(RecCount).Output.Company = Trim$(temp$)
   Control Get Text hWin, %IDR_Msg To temp$      : DlgData(RecCount).Output.Msg = Trim$(temp$)
   Control Get Text hWin, %IDR_Loc To temp$      : DlgData(RecCount).Output.loc = Trim$(temp$)
   Control Get Text hWin, %IDR_Country To temp$  : DlgData(RecCount).Output.Country = Trim$(temp$)
   Control Get Text hWin, %IDR_Category To temp$ : DlgData(RecCount).Output.Category = Trim$(temp$)
   Control Get Text hWin, %IDR_Events To temp$   : DlgData(RecCount).Output.Events = Trim$(temp$)
   Control Get Text hWin, %IDR_Blog To temp$     : DlgData(RecCount).Output.Blog = Trim$(temp$)
End Sub

Sub SaveRecordDialogOutput(RecCount As Long)
   Local temp$
   If DlgData(RecCount).Flag = %AddRecord Then
      '%AddRecord
      ReDim Preserve D(UBound(D)+1)
      D(UBound(D)) = DlgData(RecCount).Output
      D(UBound(D)).Date = CDate
      D(UBound(D)).Flag = "1"
      'add row to ListView
      LoadListViewFromD
      If ShowEditor Then LoadTextBoxFromD
      Control Set Focus hDlg, %IDC_ListView
      ListView Visible hDlg, %IDC_ListView, UBound(D)
      ListView Select hDlg, %IDC_ListView, UBound(D)
      ListView_SetItemState hListView, UBound(D)-1, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code
      ShowSelectionInStatusBar
      'add node to TreeView
      If ShowTree Then LoadTreeViewFromLV : SelectTVFromLV
   Else
      '%EditRecord
      D(DlgData(RecCount).iPos) = DlgData(RecCount).Output
      D(DlgData(RecCount).iPos).date = CDate
      FillListViewRow DlgData(RecCount).iPos, DlgData(RecCount).iSelect   'also fills Editor
      If DlgData(RecCount).Input.Category <> DlgData(RecCount).Output.Category Then
         'build entire TreeView
         If ShowTree Then LoadTreeViewFromLV : SelectTVFromLV
      Else
         'just change name in TreeView
         ListView Get Text hDlg, %IDC_ListView, DlgData(RecCount).iPos, 13 To temp$  'TreeView node
         Treeview Set Text hDlg, %IDC_TreeView, Val(temp$), D(DlgData(RecCount).iPos).name
         Treeview Select hDlg, %IDC_TreeView, Val(temp$)
      End If
   End If
   'set/show status
   FileChanged = 1
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Save, IIf(FileChanged,%TBState_Enabled,%TBState_Disabled)
End Sub

'Ascending Sorts--------------------------
' -1 if 1st should precede 2nd : +1 if 2nd should precede 2nd
Function SortByNameA(A As BohoData, B As BohoData) As Long   'forum-date ascending
   Function = IIf(LCase$(A.name)<LCase$(B.name), -1, +1)
End Function

Function SortByPhoneA(A As BohoData, B As BohoData) As Long   'forum-date ascending
   Function = IIf(LCase$(A.phone)<LCase$(B.phone), -1, +1)
End Function

Function SortByEmailA(A As BohoData, B As BohoData) As Long   'forum-date ascending
   Function = IIf(LCase$(A.email)<LCase$(B.email), -1, +1)
End Function

Function SortByDateNameA(A As BohoData, B As BohoData) As Long   'author-date ascending
   If LCase$(A.Date) < LCase$(B.Date) Then Function = -1 : Exit Function
   If LCase$(A.Date) > LCase$(B.Date) Then Function = +1 : Exit Function
   If LCase$(A.Name) < LCase$(B.Name) Then Function = -1 : Exit Function
   If LCase$(A.Name) > LCase$(B.Name) Then Function = +1 : Exit Function
End Function

Function SortByCategoryNameA(A As BohoData, B As BohoData) As Long   'author-date ascending
   If LCase$(A.Category) < LCase$(B.Category) Then Function = -1 : Exit Function
   If LCase$(A.Category) > LCase$(B.Category) Then Function = +1 : Exit Function
   If LCase$(A.Name) < LCase$(B.Name) Then Function = -1 : Exit Function
   If LCase$(A.Name) > LCase$(B.Name) Then Function = +1 : Exit Function
End Function

Function SortByLocNameA(A As BohoData, B As BohoData) As Long   'author-date ascending
   If LCase$(A.Loc) < LCase$(B.Loc) Then Function = -1 : Exit Function
   If LCase$(A.Loc) > LCase$(B.Loc) Then Function = +1 : Exit Function
   If LCase$(A.Name) < LCase$(B.Name) Then Function = -1 : Exit Function
   If LCase$(A.Name) > LCase$(B.Name) Then Function = +1 : Exit Function
End Function

Function SortByCountryNameA(A As BohoData, B As BohoData) As Long   'author-date ascending
   If LCase$(A.Country) < LCase$(B.Country) Then Function = -1 : Exit Function
   If LCase$(A.Country) > LCase$(B.Country) Then Function = +1 : Exit Function
   If LCase$(A.Name) < LCase$(B.Name) Then Function = -1 : Exit Function
   If LCase$(A.Name) > LCase$(B.Name) Then Function = +1 : Exit Function
End Function

Function SortByAttachNameA(A As BohoData, B As BohoData) As Long   'author-date ascending
   If LCase$(A.bname) < LCase$(B.bname) Then Function = -1 : Exit Function
   If LCase$(A.bname) > LCase$(B.bname) Then Function = +1 : Exit Function
   If LCase$(A.Name) < LCase$(B.Name) Then Function = -1 : Exit Function
   If LCase$(A.Name) > LCase$(B.Name) Then Function = +1 : Exit Function
End Function

Function SortByEventsNameA(A As BohoData, B As BohoData) As Long   'author-date ascending
   If LCase$(A.events) < LCase$(B.events) Then Function = -1 : Exit Function
   If LCase$(A.events) > LCase$(B.events) Then Function = +1 : Exit Function
   If LCase$(A.Name) < LCase$(B.Name) Then Function = -1 : Exit Function
   If LCase$(A.Name) > LCase$(B.Name) Then Function = +1 : Exit Function
End Function

Function SortByMsgNameA(A As BohoData, B As BohoData) As Long   'author-date ascending
   If LCase$(A.msg) < LCase$(B.msg) Then Function = -1 : Exit Function
   If LCase$(A.msg) > LCase$(B.msg) Then Function = +1 : Exit Function
   If LCase$(A.Name) < LCase$(B.Name) Then Function = -1 : Exit Function
   If LCase$(A.Name) > LCase$(B.Name) Then Function = +1 : Exit Function
End Function

Function SortByCompanyNameA(A As BohoData, B As BohoData) As Long   'author-date ascending
   If LCase$(A.company) < LCase$(B.company) Then Function = -1 : Exit Function
   If LCase$(A.company) > LCase$(B.company) Then Function = +1 : Exit Function
   If LCase$(A.Name) < LCase$(B.Name) Then Function = -1 : Exit Function
   If LCase$(A.Name) > LCase$(B.Name) Then Function = +1 : Exit Function
End Function

'Descending Sorts--------------------------
Function SortByNameD(A As BohoData, B As BohoData) As Long   'forum-date ascending
   Function = IIf(LCase$(A.name)<LCase$(B.name), 1, -1)
End Function

Function SortByPhoneD(A As BohoData, B As BohoData) As Long   'forum-date ascending
   Function = IIf(LCase$(A.phone)<LCase$(B.phone), 1, -1)
End Function

Function SortByEmailD(A As BohoData, B As BohoData) As Long   'forum-date ascending
   Function = IIf(LCase$(A.email)<LCase$(B.email), 1, -1)
End Function

Function SortByDateNameD(A As BohoData, B As BohoData) As Long   'author-date ascending
   If LCase$(A.Date) < LCase$(B.Date) Then Function = 1 : Exit Function
   If LCase$(A.Date) > LCase$(B.Date) Then Function = -1 : Exit Function
   If LCase$(A.Name) < LCase$(B.Name) Then Function = 1 : Exit Function
   If LCase$(A.Name) > LCase$(B.Name) Then Function = -1 : Exit Function
End Function

Function SortByCategoryNameD(A As BohoData, B As BohoData) As Long   'author-date ascending
   If LCase$(A.Category) < LCase$(B.Category) Then Function = 1 : Exit Function
   If LCase$(A.Category) > LCase$(B.Category) Then Function = -1 : Exit Function
   If LCase$(A.Name) < LCase$(B.Name) Then Function = 1 : Exit Function
   If LCase$(A.Name) > LCase$(B.Name) Then Function = -1 : Exit Function
End Function

Function SortByLocNameD(A As BohoData, B As BohoData) As Long   'author-date ascending
   If LCase$(A.Loc) < LCase$(B.Loc) Then Function = 1 : Exit Function
   If LCase$(A.Loc) > LCase$(B.Loc) Then Function = -1 : Exit Function
   If LCase$(A.Name) < LCase$(B.Name) Then Function = 1 : Exit Function
   If LCase$(A.Name) > LCase$(B.Name) Then Function = -+1 : Exit Function
End Function

Function SortByCountryNameD(A As BohoData, B As BohoData) As Long   'author-date ascending
   If LCase$(A.Country) < LCase$(B.Country) Then Function = 1 : Exit Function
   If LCase$(A.Country) > LCase$(B.Country) Then Function = -1 : Exit Function
   If LCase$(A.Name) < LCase$(B.Name) Then Function = 1 : Exit Function
   If LCase$(A.Name) > LCase$(B.Name) Then Function = -1 : Exit Function
End Function

Function SortByAttachNameD(A As BohoData, B As BohoData) As Long   'author-date ascending
   If LCase$(A.bname) < LCase$(B.bname) Then Function = 1 : Exit Function
   If LCase$(A.bname) > LCase$(B.bname) Then Function = -1 : Exit Function
   If LCase$(A.Name) < LCase$(B.Name) Then Function = 1 : Exit Function
   If LCase$(A.Name) > LCase$(B.Name) Then Function = -1 : Exit Function
End Function

Function SortByEventsNameD(A As BohoData, B As BohoData) As Long   'author-date ascending
   If LCase$(A.events) < LCase$(B.events) Then Function = 1 : Exit Function
   If LCase$(A.events) > LCase$(B.events) Then Function = -1 : Exit Function
   If LCase$(A.Name) < LCase$(B.Name) Then Function = 1 : Exit Function
   If LCase$(A.Name) > LCase$(B.Name) Then Function = -1 : Exit Function
End Function

Function SortByMsgNameD(A As BohoData, B As BohoData) As Long   'author-date ascending
   If LCase$(A.msg) < LCase$(B.msg) Then Function = 1 : Exit Function
   If LCase$(A.msg) > LCase$(B.msg) Then Function = -1 : Exit Function
   If LCase$(A.Name) < LCase$(B.Name) Then Function = 1 : Exit Function
   If LCase$(A.Name) > LCase$(B.Name) Then Function = -1 : Exit Function
End Function

Function SortByCompanyNameD(A As BohoData, B As BohoData) As Long   'author-date ascending
   If LCase$(A.company) < LCase$(B.company) Then Function = 1 : Exit Function
   If LCase$(A.company) > LCase$(B.company) Then Function = -1 : Exit Function
   If LCase$(A.Name) < LCase$(B.Name) Then Function = 1 : Exit Function
   If LCase$(A.Name) > LCase$(B.Name) Then Function = -1 : Exit Function
End Function

Sub SetHeaderIcons(ActiveColumn As Long)
   If Debug Then Txt.Print FuncName$
   Local i As Integer, hdi As HD_ITEM
   For i = 0 To 7 'Header_GetItemCount(hHeader) - 1
      hdi.mask = %HDI_FORMAT Or %HDI_IMAGE
      hdi.fmt = %HDF_String Or %HDF_Image Or %HDF_Bitmap_On_Right       'left is the default
      If i = ActiveColumn Then hdi.iImage = SortDirection Else hdi.iImage = 3
      Header_SetItem(hHeader, i, hdi)
   Next i
End Sub

Sub OpenDataBase
   If Debug Then Txt.Print FuncName$
   Local temp$
   If FileChanged Then
      Select Case MsgBoxX("Current file changed. Save changes?", %MB_YesNoCancel + %MB_IconQuestion + %MB_TaskModal, "Open Database")
         Case %IdYes
            SaveDToFile
         Case %IdNo
            'no action. close without saving changes
         Case %IdCancel
            Exit Sub
      End Select
   End If
   temp$ = SelectFileToOpen("Open Database", %OFN_Explorer Or %OFN_FileMustExist Or %OFN_HideReadOnly, Chr$("Text",0,"*.txt",0))
   If Len(temp$) Then
      FileName = temp$
      SetDialogTitle
      LoadDataFromFileToD
      ViewAllRecords
      FileChanged = 0
      Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Save, IIf(FileChanged,%TBState_Enabled,%TBState_Disabled)
   End If

End Sub

Sub NewDataBase
   If Debug Then Txt.Print FuncName$
   If FileChanged Then
      Select Case MsgBoxX("Current file changed. Save changes?", %MB_YesNoCancel + %MB_IconQuestion + %MB_TaskModal, "New Database")
         Case %IdYes
            SaveDToFile
         Case %IdNo
            'no action. create new database without saving changes
         Case %IdCancel
            Exit Sub
      End Select
   End If
   CreateEmptyDataBase
   SetDialogTitle
   ViewAllRecords
   FileChanged = 0
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Save, IIf(FileChanged,%TBState_Enabled,%TBState_Disabled)
End Sub

Sub SaveDToFileAs
   If Debug Then Txt.Print FuncName$
   Local temp$
   If Debug Then Txt.Print FuncName$
   temp$ = SelectFileToSaveAs("Save As", %OFN_PathMustExist Or %OFN_Explorer Or %OFN_OverWritePrompt, Chr$("Text",0,"*.txt",0))
   If Len(temp$) Then
      FileName = temp$
      SetDialogTitle
      SaveDToFile
      FileChanged = 0
      Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Save, IIf(FileChanged,%TBState_Enabled,%TBState_Disabled)
   End If
End Sub

Function SelectFileToSaveAs(title$, flags&, filter$) As String
    If Debug Then Txt.Print FuncName$
    Local startfolder$, startfile$, defaultext$, filevar$, countvar&
    startfolder$ = IIf$(Len(FileName), FileName, Exe.Path$)     'initial folder to be displayed
    defaultext$ = ".txt"
    startfile$ = (FileName)       'name to be used as initial selection
    Display Savefile hDlg, 100, 100, title$, startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
    If Len(filevar$) Then Function = filevar$       '
End Function

Function SelectFileToOpen(title$, flags&, filter$) As String
    If Debug Then Txt.Print FuncName$
    Local startfolder$, startfile$, defaultext$, filevar$, countvar&
    startfolder$ = IIf$(Len(FileName), FileName, Exe.Path$)     'initial folder to be displayed
    startfile$ = (FileName)       'name to be used as initial selection
    Display Openfile hDlg, 100, 100, title$, startfolder$, filter$, startfile$, defaultext$, flags& To filevar$, countvar&
    If Len(filevar$) Then Function = filevar$       '
End Function

Sub LoadTextBoxFromD
   If Debug Then Txt.Print FuncName$
   Local iPos,iResult As Long, temp$
   ListView Get Select hDlg, %IDC_Listview To iResult         'LV selected row
   If iResult = 0 Then
      Control Set Text hDlg, %IDC_TextBox, ""
      Exit Sub
   End If
   ListView Get Text hDlg, %IDC_ListView, iResult, 12 To temp$ 'array POS
   iPos = Val(temp$)
   temp$ = Trim$(D(iPos).name)
   temp$ = temp$ + $CrLf + Trim$(D(iPos).phone)
   temp$ = temp$ + $CrLf + Trim$(D(iPos).email)
   temp$ = temp$ + $CrLf + Trim$(D(iPos).company)
   temp$ = temp$ + $CrLf + Trim$(D(iPos).msg)
   temp$ = temp$ + $CrLf + Trim$(D(iPos).loc)
   temp$ = temp$ + $CrLf + Trim$(D(iPos).country)
   temp$ = temp$ + $CrLf + Trim$(D(iPos).category)
   temp$ = temp$ + $CrLf + Trim$(D(iPos).events)
   temp$ = temp$ + $CrLf + Trim$(D(iPos).blog)
   Control Set Text hDlg, %IDC_TextBox, temp$
End Sub

Sub LoadTreeViewFromLV
   If Debug Then Txt.Print FuncName$
   Local iPos, iCount As Long, tmp$, temp$, rname$, cat$, hNode,hTemp As Dword

SendMessage hTree, %WM_SetRedraw, 0, 0
   Treeview Reset hDlg, %IDC_TreeView

   'Build root nodes
   ListView Get Count hDlg, %IDC_ListView To iCount
   For iPos = 1 To iCount
      ListView Get Text hDlg, %IDC_ListView, iPos, 8 To temp$  'category
      If InStr(LCase$(cat$), Chr$(7) + LCase$(temp$) + Chr$(7)) = 0  Then
         cat$ = cat$ + $Spc + Chr$(7) + temp$ + Chr$(7)
         Treeview Insert Item hDlg, %IDC_TreeView, 0, %TVI_Last, 0, 0, temp$ To hNode
      End If
   Next i
   Control Send hDlg, %IDC_TreeView, %TVM_SortChildren, %False, 0    'children only

   'Build sub-nodes
   For iPos = 1 To iCount
      ListView Get Text hDlg, %IDC_ListView, iPos, 8 To temp$  'category
      ListView Get Text hDlg, %IDC_ListView, iPos, 1 To rname$   'name
      Treeview Get Child hDlg, %IDC_TreeView,0 To hNode
      Do While hNode
         Treeview Get Text hDlg, %IDC_TreeView, hNode To tmp$  'category
         If tmp$ = temp$ Then
            Treeview Insert Item hDlg, %IDC_TreeView, hNode, %TVI_Last, 0, 0, rname$ To hTemp
            Treeview Set User hDlg, %IDC_TreeView, hTemp, iPos
            ListView Set Text hDlg, %IDC_ListView, iPos, 13, Trim$(Str$(hTemp))  'TreeView node
            Exit Do
         End If
         Treeview Get Next hDlg, %IDC_TreeView, hNode To hNode
      Loop
   Next i
SendMessage hTree, %WM_SetRedraw, 1, 0
Control ReDraw hDlg, %IDC_TreeView

End Sub

Function TextBoxProc(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local x,y As Long
   Select Case Msg
      Case %WM_ContextMenu
         SetFocus hWnd
         x = Lo(Integer,lParam) : y = Hi(Integer, lParam)    'WM_ContextMenu returns xy coordinates of mouse
         TrackPopupMenu hContextTB, %TPM_LeftAlign, x, y, 0, hDlg, ByVal 0   'put context menu where mouse is
         Function = 0 : Exit Function
   End Select
   Function = CallWindowProc(OldProcTB, hWnd, Msg, wParam, lParam)
End Function

Sub ApplyChanges
   If Debug Then Txt.Print FuncName$
   Local i,j,iPos, iRow As Long, hNode As Dword, temp$, tempBoho As BohoData
   'get LV Row and TreeView Node
   ListView Get Select hDlg, %IDC_ListView To iRow
   ListView Get Text hDlg, %IDC_ListView, iRow, 12 To temp$  'array pos
   iPos = Val(temp$)
   ListView Get Text hDlg, %IDC_ListView, iRow, 13 To temp$  'TreeView node
   hNode = Val(temp$)
   'get pre-Change information
   tempBoho = D(iPos)
   Control Get Text hDlg, %IDC_TextBox To temp$
   D(iPos).name     = Trim$(Parse$(temp$,$CrLf,1))
   D(iPos).phone    = Trim$(Parse$(temp$,$CrLf,2))
   D(iPos).email    = Trim$(Parse$(temp$,$CrLf,3))
   D(iPos).company  = Trim$(Parse$(temp$,$CrLf,4))
   D(iPos).msg      = Trim$(Parse$(temp$,$CrLf,5))
   D(iPos).loc      = Trim$(Parse$(temp$,$CrLf,6))
   D(iPos).country  = Trim$(Parse$(temp$,$CrLf,7))
   D(iPos).category = Trim$(Parse$(temp$,$CrLf,8))
   D(iPos).events   = Trim$(Parse$(temp$,$CrLf,9))
   For i = 1 To 9 : j = InStr(j+1,temp$,$CrLf) : Next i
   D(iPos).blog = Mid$(temp$,j+2)
   D(iPos).date = CDate
   If tempBoho = D(iPos) Then Exit Sub
   'put new data in ListView
   FillListViewRow(iPos,iRow)  'also fills Editor
   If ShowTree Then
      If tempBoho.category = D(iPos).category Then
         'TreeView name change only
         Treeview Set Text hDlg, %IDC_TreeView, hNode, Trim$(D(iPos).name)
      Else
         'rebuild TreeView because category has changed
         LoadTreeViewFromLV : SelectTVFromLV
      End If
   End If

   'closeout
   FileChanged = 1
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Save, IIf(FileChanged,%TBState_Enabled,%TBState_Disabled)
End Sub

Sub ResetColW
   If Debug Then Txt.Print FuncName$
   ListView Set Column hDlg, %IDC_ListView, 1, 150
   ListView Set Column hDlg, %IDC_ListView, 2, 100
   ListView Set Column hDlg, %IDC_ListView, 3, 150
   ListView Set Column hDlg, %IDC_ListView, 4, 80
   ListView Set Column hDlg, %IDC_ListView, 5, 100
   ListView Set Column hDlg, %IDC_ListView, 6, 100
   ListView Set Column hDlg, %IDC_ListView, 7, 75
   ListView Set Column hDlg, %IDC_ListView, 8, 150
   ListView Set Column hDlg, %IDC_ListView, 9, 150
   ListView Set Column hDlg, %IDC_ListView, 10, 150
   ListView Set Column hDlg, %IDC_ListView, 11, 40
   ListView Set Column hDlg, %IDC_ListView, 12, 100
End Sub

Sub AttachFile
   If Debug Then Txt.Print FuncName$
   Local iPos,iRow As Long, fName$, temp$
   fName$ = SelectFileToSaveAs("Save As", %OFN_PathMustExist Or %OFN_Explorer Or %OFN_OverWritePrompt, Chr$("All Files",0,"*.*",0))
   If Len(fName$) Then
      ListView Get Select hDlg, %IDC_ListView To iRow
      ListView Get Text hDlg, %IDC_ListView, iRow, 12 To temp$  'array Pos
      iPos = Val(temp$)
      D(iPos).bname = PathName$(Namex,fName$)
      ListView Set Text hDlg, %IDC_ListView, iRow, 10, PathName$(Namex,fName$)   'attachment

      Open fName$ For Binary As #1
      Attachment = Space$(Lof(1))
      Get #1, , Attachment
      Close #1

      Open FileName + ".bin" For Binary As #1
      D(iPos).bstart = Str$(Lof(1) + 1)
      Put #1,Lof(1)+1,Attachment
      D(iPos).bend = Str$(Lof(1))
      Close #1

      FileChanged = 1
      Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Save, IIf(FileChanged,%TBState_Enabled,%TBState_Disabled)
      MsgBoxX(RecordTextB(D(iPos)), %MB_Ok + %MB_IconInformation, "Attach File")
   End If
End Sub

Sub RemoveAttachment
   If Debug Then Txt.Print FuncName$
   Local iPos As Long, temp$
   ListView Get Select hDlg, %IDC_ListView To iPos
   ListView Get Text hDlg, %IDC_ListView, iPos, 12 To temp$  'array pos
   iPos = Val(temp$)
   If Val(D(iPos).bstart) Then
      D(iPos).bname = "-"
      D(iPos).bstart = "-"
      D(iPos).bend = "-"
      D(iPos).date = CDate
      FileChanged = 1
      Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Save, IIf(FileChanged,%TBState_Enabled,%TBState_Disabled)
      Statusbar Set Text hDlg, %IDC_StatusBar, 1,0, "Attach removed ... "
   Else
      MsgBoxX("No attachment associated with record!", %MB_Ok + %MB_IconInformation + %MB_TaskModal, "View Attachment")
   End If
End Sub

Sub ViewAttachment
   If Debug Then Txt.Print FuncName$
   Local iPos As Long, temp$
   ListView Get Select hDlg, %IDC_ListView To iPos
   ListView Get Text hDlg, %IDC_ListView, iPos, 12 To temp$  'Array pos
   iPos = Val(temp$)

   If Val(D(iPos).bstart) = 0 Then
      MsgBoxX("No attachment associated with record!", %MB_Ok + %MB_IconInformation + %MB_TaskModal, "View Attachment")
   Else
      If IsFalse(IsFile(FileName + ".bin")) Then
         MsgBoxX("Attachment file not found!", %MB_Ok + %MB_IconExclamation, "View Attachment")
         Exit Sub
      End If

      Open FileName + ".bin" For Binary As #1

      If Lof(1) = 0 Then
         MsgBoxX("Attachment file is empty!", %MB_Ok + %MB_IconExclamation, "View Attachment")
         Close #1
         Exit Sub
      End If

      Attachment = Space$(Val(D(iPos).bend) - Val(D(iPos).bstart) + 1)
      Get #1, Val(D(iPos).bstart), Attachment
      Close #1
      temp$ = "temp\" + Trim$(D(iPos).bname)
      Open temp$ For Binary As #1
      Put #1, , Attachment
      Close #1
      iPos = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)
   End If
End Sub

Sub CompactAttachmentFile
   If Debug Then Txt.Print FuncName$
   Local iPos As Long

   If IsFalse(IsFile(FileName + ".bin")) Then
      MsgBoxX("Attachment file not found!", %MB_Ok + %MB_IconExclamation, "View Attachment")
      Exit Sub
   End If

   Open FileName + ".bin" For Binary As #1

   If Lof(1) = 0 Then
      MsgBoxX("Attachment file is empty!", %MB_Ok + %MB_IconExclamation, "View Attachment")
      Close #1
      Exit Sub
   End If

   If IsFile(FileName + ".bin" + ".tmp") Then Kill FileName + ".bin" + ".tmp"
   Name FileName + ".bin" As FileName + ".bin" + ".tmp"  'rename original as *.tmp
   Open FileName + ".bin" + ".tmp" For Binary As #1      'open *.tmp file for reading
   Open FileName + ".bin" For Binary As #2               'create new, empty file with same name as original
   For iPos = 1 To UBound(D)
      If Val(D(iPos).bstart) = 0 Then Iterate For
      Attachment = Space$(Val(D(iPos).bend) - Val(D(iPos).bstart) + 1)
      Get #1, Val(D(iPos).bstart), Attachment
      D(iPos).bstart = Str$(Lof(2) + 1)
      Put #2, , Attachment
      D(iPos).bend = Str$(Lof(2))
   Next i
   Close #1
   Close #2
End Sub

Sub ResizeWindow
   'sideview     'categoryview      'hide datepos
   If Debug Then Txt.Print FuncName$
   Local w,h,X As Long
   Dialog Get Client hDlg To w,h

   X = BigEditor * 100   'extra size for Editor

   If ShowToolbar Then
      If ShowTree Then
         If ShowEditor Then
            Control Set Loc hDlg, %IDC_Label, w-240-X, 63
            Control Set Loc hDlg, %IDC_TextBox, w-200-X, 60
            Control Set Size hDlg, %IDC_TextBox, 190+X,h-90
            Control Set Loc hDlg, %IDC_TreeView, 10, 60
            Control Set Size hDlg, %IDC_TreeView, 150,h-90
            Control Set Loc hDlg, %IDC_ListView, 170, 60
            Control Set Size hDlg, %IDC_ListView, w-420-X,h-90
         Else
            Control Set Loc hDlg, %IDC_TreeView, 10, 60
            Control Set Size hDlg, %IDC_TreeView, 150,h-90
            Control Set Loc hDlg, %IDC_ListView, 170, 60
            Control Set Size hDlg, %IDC_ListView, w-180,h-90
         End If
      Else
         If ShowEditor Then
            Control Set Loc hDlg, %IDC_Label, w-240-X,63
            Control Set Loc hDlg, %IDC_TextBox, w-200-X,60
            Control Set Size hDlg, %IDC_TextBox, 190+X,h-90
            Control Set Loc hDlg, %IDC_ListView, 10, 60
            Control Set Size hDlg, %IDC_ListView, w-260-X,h-90
         Else
            Control Set Loc hDlg, %IDC_ListView, 10, 60
            Control Set Size hDlg, %IDC_ListView, w-20,h-90
         End If
      End If
   Else
      If ShowTree Then
         If ShowEditor Then
            Control Set Loc hDlg, %IDC_Label, w-240-X, 13
            Control Set Loc hDlg, %IDC_TextBox, w-200-X, 10
            Control Set Size hDlg, %IDC_TextBox, 190+X,h-40
            Control Set Loc hDlg, %IDC_TreeView, 10, 10
            Control Set Size hDlg, %IDC_TreeView, 150,h-40
            Control Set Loc hDlg, %IDC_ListView, 180, 10
            Control Set Size hDlg, %IDC_ListView, w-440-X,h-40
         Else
            Control Set Loc hDlg, %IDC_TreeView, 10, 10
            Control Set Size hDlg, %IDC_TreeView, 150,h-40
            Control Set Loc hDlg, %IDC_ListView, 170, 10
            Control Set Size hDlg, %IDC_ListView, w-170,h-40
         End If
      Else
         If ShowEditor Then
            Control Set Loc hDlg, %IDC_Label, w-240-X, 13
            Control Set Loc hDlg, %IDC_TextBox, w-200-X, 10
            Control Set Size hDlg, %IDC_TextBox, 190+X,h-40
            Control Set Loc hDlg, %IDC_ListView, 10, 10
            Control Set Size hDlg, %IDC_ListView, w-260-X,h-40
         Else
            Control Set Loc hDlg, %IDC_ListView, 10, 10
            Control Set Size hDlg, %IDC_ListView, w-20,h-40
         End If
      End If
   End If

End Sub

Sub FindSearchTerm
   If Debug Then Txt.Print FuncName$
   Local j, iPos,iCount,iResult As Long, sTerm$, text$
   Control Get Text hSearch, %IDS_SearchTerm To SearchTerm : SearchTerm = Trim$(SearchTerm)
   If SearchTerm = "..all" Then ViewAllRecords : Exit Sub

   Control Get Check hSearch, %IDS_Case To CaseSensitive
   Control Get Check hSearch, %IDS_WholeWord To WholeWords
   If CaseSensitive = 0 Then sTerm$ = LCase$(SearchTerm) Else sTerm$ = SearchTerm
   Control Get Check hSearch, %IDS_STRING To iResult : If iResult Then SearchMode = %SearchAsString
   Control Get Check hSearch, %IDS_AND To iResult    : If iResult Then SearchMode = %SearchAllTerms
   Control Get Check hSearch, %IDS_OR To iResult     : If iResult Then SearchMode = %SearchAnyTerm

    'create search term list in array T().
    If SearchMode = %SearchAsString Then
        'use as one long term. spaces are not removed, nor trimmed from ends of search string
        ReDim T(0) As String
        T(0) = sTerm$
    Else
        'search all terms or all terms, so split into multiple terms on $SPC
        sTerm$ = Shrink$(sTerm$)        'remove contiguous, start/end spaces
        ReDim T(ParseCount(sTerm$, " ")-1) As String                             'create array of terms
        Parse sTerm$, T(), " "
    End If

   'set all record to NOT display
   For iPos = 1 To UBound(D) : D(iPos).flag = "-" : Next iPos

   'search
   For iPos = 1 To UBound(D)
      If CaseSensitive Then text$ = RecordText(iPos,$Spc) Else text$ = LCase$(RecordText(iPos,$Spc))

      Select Case SearchMode
         Case %SearchAsString   '= on toolbar - Complete String
            iResult = InStrW(text$,sterm$)
            If iResult Then D(iPos).flag = "1" Else D(iPos).flag = "-"

         Case %SearchAnyTerm   'OR on toolbar - Any Word in the document
            iResult = 0
            For j = 0 To UBound(T)
               If InStrW(text$,T(j)) Then iResult = 1 : Exit For
            Next j
            If iResult Then D(iPOs).flag = "1" Else D(iPos).flag = "-"

         Case %SearchAllTerms  'AND on toolbar -  'All Words somewhere in document OR all on one line if WordsOnLine=1
            'does file have all the words in it
            iResult = 1
            For j = 0 To UBound(T)
               If InStrW(text$,T(j)) = 0  Then iResult = 0 : Exit For
            Next j
            If iResult Then D(iPos).flag = "1" Else D(iPos).flag = "-"
      End Select
   Next iPos

   LoadListViewFromD
   If ShowTree Then LoadTreeViewFromLV : SelectTVFromLV
   If ShowEditor Then LoadTextBoxFromD
   FileChanged = 1
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Save, IIf(FileChanged,%TBState_Enabled,%TBState_Disabled)
   Statusbar Set Text hDlg, %IDC_Toolbar, 1,0, "Matching Records: " + Str$(iCount)
End Sub

Sub SelectTVFromLV
   If Debug Then Txt.Print FuncName$
   Local temp$, iPos As Long
   ListView Get Select hDlg, %IDC_Listview To iPos
   ListView Get Text hDlg, %IDC_ListView, iPos, 13 To temp$  'TreeView node
   Treeview Select hDlg, %IDC_TreeView, Val(temp$)
   SendMessage hTree, %TVM_EnsureVisible, 0, Val(temp$)
End Sub

Sub SendEmail
   If Debug Then Txt.Print FuncName$
   Local iReturn As Long, temp$
   ListView Get Select hDlg, %IDC_ListView To iReturn
   ListView Get Text hDlg, %IDC_ListView, iReturn, 3 To temp$
   If temp$ = "-" Or temp$ = "" Then Beep : Exit Sub
   iReturn = ShellExecute(hDlg, "Open", "mailto:" + temp$ , $Nul, $Nul, %SW_ShowNormal)
End Sub

Sub SendTextMsg
   If Debug Then Txt.Print FuncName$
   Local iReturn As Long, temp$, tmp$
   ListView Get Select hDlg, %IDC_ListView To iReturn
   ListView Get Text hDlg, %IDC_ListView, iReturn, 2 To temp$
   Replace "-" With "" In temp$
   ListView Get Text hDlg, %IDC_ListView, iReturn, 5 To tmp$
   If temp$ = "-" Or temp$ = "" Then Beep : Exit Sub
   iReturn = ShellExecute(hDlg, "Open", "mailto:" + temp$+"@"+Carrier(tmp$) , $Nul, $Nul, %SW_ShowNormal)
End Sub

Sub OpenURL
   If Debug Then Txt.Print FuncName$
   Local temp$, iResult, iStartPos, iEndPos As Long
   Control Get Text hDlg, %IDC_TextBox To temp$
   Control Send hDlg, %IDC_TextBox, %EM_GetSel, VarPtr(iStartPos), VarPtr(iEndPos)  'zero-based start/stop positions
   temp$ = Mid$(temp$,iStartPos+1, iEndPos-iStartPos)
   iResult = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)
End Sub

Sub BackupDataBase
   If Debug Then Txt.Print FuncName$
   Local temp$
   temp$ = "backup\" + CDate + " " + PathName$(Namex,FileName)
   Replace Any ": -" With "___" In temp$
   If IsFile(FileName) Then FileCopy FileName, temp$
   If IsFile(FileName + ".bin") Then FileCopy FileName + ".bin", temp$ + ".bin.bak"
End Sub

Function InstanceTest() As Long
   If Debug Then Txt.Print FuncName$
   'returns 0 if instance exits or cannot create mutex. otherwise returns 1.
   Local UniqueName As WStringZ * %Max_Path, hTry As Dword
   UniqueName = "gbTextDB"
   If CreateMutex(ByVal %Null, 0, UniqueName) = 0 Or GetLastError = %ERROR_ALREADY_EXISTS Then
      hTry = GeTTopWindow(%HWND_Desktop)
      Do While hTry
         If GetWindowLong(hTry, %GWL_UserData) = %UniqueNumber Then Exit Do
         hTry = GetWindow(hTry, %GW_HWNDNEXT)
      Loop
      If hTry Then
         ShowWindow(hTry, %SW_Restore)
         ShowWindow(hTry, %SW_Show)
         SetForegroundWindow(hTry)
      End If
      Beep
      Function = 0
   Else
      Function = 1
   End If
End Function

Function InstrW(smain$,sterm$) As Long
'    If Debug Then Txt.Print FuncName$    '<--- turned off by choice
    Local iPos,FlagLeft,FlagRight As Long, rChar$, lChar$

    'find sterm$ (not the whole word version)
    iPos = InStr(smain$, sterm$)
    If WholeWords = 0 Then Function = iPos : Exit Function

    Do While iPos
        FlagLeft = %False : FlagRight = %False
        'check left side
        If iPos = 1 Then
            FlagLeft = %True                   'flush with left side of line
        Else
            lChar$ = Mid$(smain$,iPos-1,1)
            FlagLeft = IsTrue(Verify(lChar$, ValidWordCharacters))
        End If
        'check right side
        If iPos = Len(smain$)-Len(sTerm$)+1 Then
            FlagRight = %True                 'flush with right side of line
        Else
            rChar$ = Mid$(smain$,iPos + Len(sterm$),1)
            FlagRight = IsTrue(Verify(rChar$, ValidWordCharacters))
        End If
        'Done?
        If FlagLeft And FlagRight Then Exit Do
        iPos = InStr(iPos+Len(sterm$), smain$, sterm$)
    Loop
    Function = iPos
End Function

Function GetPSW As String
   If Debug Then Txt.Print FuncName$
   Local temp$, x,y As Long
   Dialog Get Loc hDlg To x,y
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(InputBoxProc), GetModuleHandle(""), GetCurrentThreadId)
   CenterOverDialog(300,90,x,y)
   temp$ = InputBox$("", "Enter password:", PSW,x,y)
   If Len(temp$) Then PSW = temp$ : Function = PSW
End Function

Function InputBoxProc(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
'   If Debug Then Txt.Print FuncName$    '<--- turned off by choice
   Local szTemp As WStringZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr
   Function = CallNextHookEx(ByVal ghHook, ByVal nCode, ByVal wParam, ByVal lParam)
   If nCode < 0 Then Exit Function
   If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx ghHook
   If nCode = %HCBT_CREATEWND Then
      cw = lParam         ' Get pointer to CBT_CREATEWND struct so we can...    TT: Nick Melnick
      cst = @cw.lpcs      ' get a pointer to the CREATESTRUCT struct
      GetClassName wParam, szTemp, %Max_Path      ' for each window / control as it is created
      If UCase$(szTemp) = "BUTTON" Then @cst.x = 170                           'ok and cancel
      If UCase$(szTemp) = "STATIC" Then @cst.x = 20   : @cst.cy = -50          'prompt
      If UCase$(szTemp) = "EDIT"   Then @cst.cx = 150 : @cst.y = @cst.y - 140  'textbox
      If UCase$(szTemp) = "EDIT"   Then SetWindowLong wparam, %GWL_Style, GetWindowLong(wParam,%GWL_Style)
      If UCase$(szTemp) = "#32770" Then @cst.cx = 265 : @cst.cy = @cst.cy - 130                'dialog
   End If
End Function

Function EncryptText_old(text$, ByVal Password As String) As String    'Hanlin
   If Debug Then Txt.Print FuncName$
   Local i,a As Long, temp$
   temp$ = text$
   For i = 1 To Len(text$)
         a = (i Mod Len(Password)) + 1        'Joseph Cote
         Asc(temp$,i) = Asc(Password,a) Xor Asc(temp$,i)
   Next i
   Function = temp$
End Function

Function EncryptText(text$, Psw$) As String    'Beene
   Local i,a As Long, temp$
   temp$ = text$
   For i = 1 To Len(text$)
      a = (i Mod Len(Psw$)) + 1        'Joseph Cote
      Mid$(temp$,i) =  (Chr$(i Xor Asc(Mid$(Psw$,a,1)) Xor Asc(Mid$(text$,i,1))))
   Next i
   Function = temp$
End Function

Sub CreateEmptyDataBase
   If Debug Then Txt.Print FuncName$
   ReDim D(0)
   D(0).name = "-" : D(0).loc = "-" : D(0).country = "-" : D(0).node = "-" : D(0).msg = "-"
   D(0).flag = "1" : D(0).date = "-" : D(0).category = "-" : D(0).bstart = "-" : D(0).bend = "-"
   D(0).email = "-" : D(0).phone = "-" : D(0).blog = "-" : D(0).bname = "-" : D(0).events = "-"
   D(0).unusedA = "-" : D(0).unusedB = "-" : D(0).unusedC = "-"

   Statusbar Set Text hDlg, %IDC_StatusBar, 1,0, "Empty dataBase created ..."
   FileName = Exe.Path$ + "NoName.txt"
   FileChanged = 0
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Save, IIf(FileChanged,%TBState_Enabled,%TBState_Disabled)
End Sub

Sub LoadDataFromFileToD
   If Debug Then Txt.Print FuncName$
   Local i,RecordCount,iPos As Long, FirstByte As String * 1
   If IsTrue(IsFile(FileName)) Then
      Open FileName For Binary As #1 : Get$ #1,1, FirstByte : Close #1
      If FirstByte = "e" Then
         If Len(GetPSW) Then
            Open FileName For Binary As #1
            Get$ #1, 1, FirstByte
            Get$ #1, Lof(1)-1, BigString
            BigString = EncryptText(BigString,PSW)
            ReDim D(0 To (Lof(1)-1) / Len(BohoData) - 1)
            Close #1
            For i = 0 To UBound(D)
               iPos = i * Len(BohoData) + 1 : D(i).name = Mid$(BigString, iPos, 35)
               iPos = iPos + 35         : D(i).phone = Mid$(BigString, iPos, 20)
               iPos = iPos + 20         : D(i).msg = Mid$(BigString, iPos, 10)
               iPos = iPos + 10         : D(i).email = Mid$(BigString, iPos, 35)
               iPos = iPos + 35         : D(i).loc = Mid$(BigString, iPos, 50)
               iPos = iPos + 50         : D(i).country = Mid$(BigString, iPos, 35)
               iPos = iPos + 35         : D(i).category = Mid$(BigString, iPos, 35)
               iPos = iPos + 35         : D(i).events = Mid$(BigString, iPos, 100)
               iPos = iPos + 100        : D(i).node = Mid$(BigString, iPos, 15)
               iPos = iPos + 15         : D(i).bname = Mid$(BigString, iPos, 50)
               iPos = iPos + 50         : D(i).bstart = Mid$(BigString, iPos, 15)
               iPos = iPos + 15         : D(i).bend = Mid$(BigString, iPos, 15)
               iPos = iPos + 15         : D(i).date = Mid$(BigString, iPos, 20)
               iPos = iPos + 20         : D(i).flag = Mid$(BigString, iPos, 1)
               iPos = iPos + 1          : D(i).unusedA = Mid$(BigString, iPos, 20)
               iPos = iPos + 20         : D(i).unusedB = Mid$(BigString, iPos, 20)
               iPos = iPos + 20         : D(i).unusedC = Mid$(BigString, iPos, 20)
               iPos = iPos + 20         : D(i).blog = Mid$(BigString, iPos, 500)
            Next i
         Else
            Beep
            CreateEmptyDataBase
         End If
      Else
         Open FileName For Input As #1
         FileScan #1, Records To RecordCount
         ReDim D(0 To RecordCount/%SavedFieldsPerRecord-1)
         For i = 0 To UBound(D)
            Line Input #1, D(i).name
            Line Input #1, D(i).phone
            Line Input #1, D(i).email
            Line Input #1, D(i).msg
            Line Input #1, D(i).loc
            Line Input #1, D(i).country
            Line Input #1, D(i).category
            Line Input #1, D(i).events
            Line Input #1, D(i).node
            Line Input #1, D(i).bname
            Line Input #1, D(i).bstart
            Line Input #1, D(i).bend
            Line Input #1, D(i).date
            Line Input #1, D(i).flag
            Line Input #1, D(i).unusedA
            Line Input #1, D(i).unusedB
            Line Input #1, D(i).unusedC
            Line Input #1, D(i).blog : Replace Chr$(32) + Chr$(7) With $CrLf In D(i).blog
         Next i
         Close #1
      End If
   Else
      CreateEmptyDataBase
   End If
End Sub

Sub SaveDToFile
   If Debug Then Txt.Print FuncName$
   Local i As Long, temp$
   If SaveEncrypted Then
      If Len(GetPSW) Then
         'special save approach
         If IsFile(FileName) Then Kill FileName
         Open FileName For Binary As #1
         For i = 0 To UBound(D) : temp$ = temp$ + D(i) : Next i
         temp$ = EncryptText(temp$, PSW)
         temp$ = "e" + temp$
         Put$ #1,temp$
         Close #1
      Else
         Beep
         Statusbar Set Text hDlg, %IDC_StatusBar, 1, 0, "Save cancelled (no password provided)!"
      End If
   Else
      Open FileName For Output As #1
      For i = 0 To UBound(D)
         Print #1, D(i).name
         Print #1, D(i).phone
         Print #1, D(i).email
         Print #1, D(i).msg
         Print #1, D(i).loc
         Print #1, D(i).country
         Print #1, D(i).category
         Print #1, D(i).events
         Print #1, D(i).node
         Print #1, D(i).bname
         Print #1, D(i).bstart
         Print #1, D(i).bend
         Print #1, D(i).date
         Print #1, D(i).flag
         Print #1, D(i).unusedA
         Print #1, D(i).unusedB
         Print #1, D(i).unusedC
         temp$ = D(i).blog
         Replace $CrLf With Chr$(32) + Chr$(7) In temp$
         If i = UBound(D) Then
            Print #1, temp$;
         Else
            Print #1, temp$
         End If
      Next i
      Close #1
   End If
   FileChanged = 0
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Save, IIf(FileChanged,%TBState_Enabled,%TBState_Disabled)
End Sub

Sub DisplayEvents
   Local yesterday$, today$, tomorrow$, nextweek$, temp$, ename$, edate$
   Local iEvent,iPos, iCount, Difference As Long

   For iPos = 1 To UBound(D)
      temp$ = Trim$(D(iPos).events)
      If temp$ = "" Then Iterate For
      If temp$ = "-" Then Iterate For
      iCount = ParseCount(temp$,$Spc)
      For iEvent = 1 To iCount/2
         ename$ = Parse$(temp$,$Spc,(2*iEvent)-1)
         edate$ = Parse$(temp$,$Spc,(2*iEvent))
         Select Case DayDifference(edate$)
            Case -5 To -1 : yesterday$ = yesterday$ + $CrLf + "   " + Trim$(D(iPos).name) + $Tab + ename$ + $Tab + edate$
            Case 0 : today$ = today$ + $CrLf + "   " + Trim$(D(iPos).name) + $Tab + ename$ + $Tab + edate$
            Case 1 To 5 : nextweek$ = nextweek$ + $CrLf + "   " + Trim$(D(iPos).name) + $Tab + ename$ + $Tab + edate$
         End Select
      Next i
   Next iPos

   temp$ =       "Prior 5 days:" + IIf$(Len(yesterday$), yesterday$, $CrLf + "   " + "none") _
         + $CrLf + $CrLf + "Today:" + IIf$(Len(today$), today$, $CrLf + "   " + "none") _
         + $CrLf + $CrLf + "Next 5 days:" + IIf$(Len(nextweek$),nextweek$,$CrLf + "   " + "none")
   MsgBoxX temp$, %MB_Ok + %MB_IconInformation, "Events"
End Sub

Function DayDifference(eDate$) As Long
   Local y1,m1,d1, y2,m2,d2 As Long, day2, day1 As Double
   m1 = Val(Left$(Date$,2))  : d1 = Val(Mid$(Date$,4,2))  : y1 = Val(Right$(Date$,4))
   m2 = Val(Left$(eDate$,2)) : d2 = Val(Mid$(eDate$,4,2)) : y2 = y1   'Val(Right$(eDate$,4))

   day1 = y1 + (m1 - 2.85) / 12
   day1 = Int(Int(Int(367 * day1) - 1.75 * Int(day1) + d1) -0.75 * Int(0.01 * day1)) + 1721119

   day2 = y2 + (m2 - 2.85) / 12
   day2 = Int(Int(Int(367 * day2) - 1.75 * Int(day2) + d2) -0.75 * Int(0.01 * day2)) + 1721119

   Function = Int(day2) - Int(day1)
End Function

Function Carrier(msg$) As String
   Select Case LCase$(msg$)
      Case "att"        : Function = m_att     '"txt.att.net"
      Case "sprint"     : Function = m_sprint  '"pm.sprint.com"
      Case "nextel"     : Function = m_nextel  '"messaging.nextel.com"
      Case "tmobile"    : Function = m_tmobile '"tmomail.net"
      Case "verizon"    : Function = m_verizon '"vtext.com"
      Case "alitel"     : Function = m_alitel  '"message.alitel.com"
      Case "boost"      : Function = m_boost   '"myboostmobile.com"
      Case "uscellular" : Function = m_uscellular '"email.uscc.net.com"
      Case "virgin"     : Function = m_virgin  '"vmobl.com"
   End Select
End Function

Sub HideToolbarButtons
   If SmallToolbar Then
      Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_New, %TBState_Hidden
      Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_SaveAs, %TBState_Hidden
      Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_View, %TBState_Hidden
      Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Attach, %TBState_Hidden
      Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_CopyChecked, %TBState_Hidden
      Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Print, %TBState_Hidden
      Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Events, %TBState_Hidden
      Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Font, %TBState_Hidden
      Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_ShowEditor, %TBState_Hidden
      Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_ShowTree, %TBState_Hidden
      Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_SaveEncrypted, %TBState_Hidden
   Else
      Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_New, %TBState_Enabled
      Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_SaveAS, %TBState_Enabled
      Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_View, %TBState_Enabled
      Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Attach, %TBState_Enabled
      Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_CopyChecked, %TBState_Enabled
      Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Print, %TBState_Enabled
      Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Events, %TBState_Enabled
      Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Font, %TBState_Enabled
      Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_ShowEditor, %TBState_Enabled
      Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_ShowTree, %TBState_Enabled
      Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_SaveEncrypted, %TBState_Enabled
   End If
   Control ReDraw hDlg, %IDC_Toolbar
End Sub

Sub ShowControls
   Control Show State hDlg, %IDC_Toolbar, IIf(ShowToolbar, %SW_Show, %SW_Hide)
   Control Show State hDlg, %IDC_TreeView, IIf(ShowTree, %SW_Show, %SW_Hide)
   Control Show State hDlg, %IDC_Label, IIf(ShowEditor, %SW_Show, %SW_Hide)
   Control Show State hDlg, %IDC_TextBox, IIf(ShowEditor, %SW_Show, %SW_Hide)
End Sub

Sub BuildHistoryMenu
   If Debug Then Txt.Print FuncName$

   Menu Delete hPopupOpen, 1
   Menu Delete hPopupOpen, 1
   Menu Delete hPopupOpen, ByCmd %IDM_MRU1
   Menu Delete hPopupOpen, ByCmd %IDM_MRU2
   Menu Delete hPopupOpen, ByCmd %IDM_MRU3
   Menu Delete hPopupOpen, ByCmd %IDM_MRU4
   Menu Delete hPopupOpen, ByCmd %IDM_MRU5

   If FileName = MRU1 Then
      'nothing
   ElseIf FileName = MRU2 Then
      MRU2 = MRU1 : MRU1 = FileName
   ElseIf FileName = MRU3 Then
      MRU3 = MRU2 : MRU2 = MRU1 : MRU1 = FileName
   ElseIf FileName = MRU4 Then
      MRU4 = MRU3 : MRU3 = MRU2 : MRU2 = MRU1 : MRU1 = FileName
   Else
      MRU5 = MRU4 : MRU4 = MRU3 : MRU3 = MRU2 : MRU2 = MRU1 : MRU1 = FileName
   End If

   If IsFile(MRU1) Then
      Menu Add String, hPopupOpen, "Clear History", %IDM_ClearHistory, %MF_Enabled
      Menu Add String, hPopupOpen, "-", %IDM_Sep, %MF_Enabled
      If IsFile(MRU1) Then Menu Add String, hPopupOpen, MRU1, %IDM_MRU1, %MF_Enabled
      If IsFile(MRU2) Then Menu Add String, hPopupOpen, MRU2, %IDM_MRU2, %MF_Enabled
      If IsFile(MRU3) Then Menu Add String, hPopupOpen, MRU3, %IDM_MRU3, %MF_Enabled
      If IsFile(MRU4) Then Menu Add String, hPopupOpen, MRU4, %IDM_MRU4, %MF_Enabled
      If IsFile(MRU5) Then Menu Add String, hPopupOpen, MRU5, %IDM_MRU5, %MF_Enabled
   End If
End Sub

Sub TakeMRUAction(cID As Long)
   If Debug Then Txt.Print FuncName$
   Local temp$
   If FileChanged Then
      If AutoSave Then
         SaveDToFile
      Else
         Select Case MsgBoxX("Current file has changes. Save changes?", %MB_YesNoCancel + %MB_IconQuestion + %MB_TaskModal, "Open Database")
            Case %IdYes
               SaveDToFile
            Case %IdNo
               'no action. open without saving changes
            Case %IdCancel
               Exit Select
         End Select
      End If
   End If
   Menu Get Text hPopupOpen, ByCmd cID To temp$
   If IsFile(temp$) Then
      FileName = temp$
      SetDialogTitle
      LoadDataFromFileToD
      ViewAllRecords
      BuildHistoryMenu
      FileChanged = 0
   End If
End Sub
